#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
FILE *ffopen(char *name,char *mode);

int main()
{
  char obs[300],model[300],oatom[300],isotope[300],line[300],output[300];
  char buffer[300],out2[300];
  double start,end,cspace,mtv,rot,sm,space,shape,begin,step;
  char key[50],infile[300];
  FILE *in,*rsp,*xmk;
  int ni,err,element,i;
  char atom[4][30] = {"atom1.dat","atom2.dat","atom3.dat","atom4.dat"};
  char out[4][30] = {"cal1.spc","cal2.spc","cal3.spc","cal4.spc"}; 

  in = ffopen("input1.dat","r");


  if(fscanf(in,"%s %s",key,obs) == EOF) {
    printf("line 1:Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %s",key,model) == EOF) {
    printf("line 2:Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %s",key,oatom) == EOF) {
    printf("line 3:Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %s",key,isotope) == EOF) {
    printf("line 4:Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %s",key,line) == EOF) {
    printf("line 5: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %s",key,output) == EOF) {
    printf("line 6: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&start) == EOF) {
    printf("line 7: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&end) == EOF) {
    printf("line 8: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&cspace) == EOF) {
    printf("line 9: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&mtv) == EOF) {
    printf("line 10: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&rot) == EOF) {
    printf("line 11: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&sm) == EOF) {
    printf("line 12: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&space) == EOF) {
    printf("line 13: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&shape) == EOF) {
    printf("line 14: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %d",key,&element) == EOF) {
    printf("line 15: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&begin) == EOF) {
    printf("line 16: Problem format in input0.dat\n");
    exit(1);
  }
  if(fscanf(in,"%s %lf",key,&step) == EOF) {
    printf("line 17: Problem format in input0.dat\n");
    exit(1);
  }

  fclose(in);

  for(i=0;i<4;i++) {
    sprintf(buffer,"newatom %s %s %d %f\n",oatom,atom[i],element,begin);
    if(system(buffer) != 0) {
      printf("error executing newatom\n");
      exit(1);
    }
    rsp = ffopen("analysis1.rsp","w");
    fprintf(rsp,"%s\n",model);
    fprintf(rsp,"%s\n",line);
    fprintf(rsp,"%s\n",atom[i]);
    fprintf(rsp,"%s\n",isotope);
    fprintf(rsp,"tmp1.out\n");
    fprintf(rsp,"%lf\n",mtv);
    fprintf(rsp,"%lf,%f\n",start,end);
    fprintf(rsp,"%lf\n",cspace);
    fclose(rsp);
    sprintf(buffer,"spectrum aint < analysis1.rsp");
    if(system(buffer) != 0) {
      printf("Error in executing SPECTRUM\n");
      exit(1);
    }
    sprintf(buffer,"avsini tmp1.out tmp2.out %f 0.6 %f",rot,cspace);
    if(system(buffer) != 0) {
      printf("Error in executing AVSINI\n");
      exit(1);
    }
    strcpy(out2,out[i]);
    sprintf(buffer,"customsm tmp2.out %s %f %f %f %f",out2,cspace,sm,space,shape); 
    if(system(buffer) != 0) {
      printf("Error in executing CUSTOMSM\n");
      exit(1);
    }
    if(system("rm tmp*.out") != 0) {
      printf("error in removing temporary files\n");
      exit(1);
    }
    begin += step;
  }
  xmk = ffopen("xmk25.rsp","w");
  fprintf(xmk,"%s+%s+%s+%s+%s\n",obs,out[0],out[1],out[2],out[3]);
  fprintf(xmk,"0\n");
  fclose(xmk);
  if(system("xmk25 < xmk25.rsp") != 0) {
    printf("Error in executing XMK25\n");
    exit(1);
  }
  sprintf(buffer,"mv cal1.spc %s",output);
  if(system(buffer) != 0) {
    printf("error in renaming output file\n");
    exit(1);
  }
  if(system("rm cal*.spc") != 0) {
    printf("error in removing temporary files\n");
    exit(1);
  }


  return(0);

}

FILE *ffopen(char *name,char *mode)
{
  FILE *fp;

  if((fp = fopen(name,mode)) == NULL) {
    printf("Cannot open file %s\n",name);
    printf("Now exiting program\n");
    exit(1);
  }
  return(fp);
}
