#include <stdio.h>
int *ivector();
void free_ivector();
int **imatrix();
void free_imatrix();

void autorec(x,y,k,n)
double *x,*y;
int k,*n;
{
  FILE *in,*out;
  double *wave,*inten;
  int *mark1,**mark2;
  int i,j,l,m[2];
  double s;
  extern double *xar,*yar;

  wave = x;
  inten = y;
  mark1 = ivector(0,10000);
  mark2 = imatrix(0,1,0,10000);

  j = 0;
  for(i=1;i<k-1;i++) {
    if(inten[i] > inten[i-1] && inten[i] >= inten[i+1]) {
      mark1[j] = i;
      j++;
    }
  }

  l = 1;
  mark2[0][0] = mark1[0];
  for(i=1;i<j-1;i++) {
    s = (inten[mark1[i+1]] - inten[mark1[i-1]])/
			    (wave[mark1[i+1]] - wave[mark1[i-1]]);
    if(inten[mark1[i]] > s*(wave[mark1[i]] - wave[mark1[i-1]]) +
			 inten[mark1[i-1]]) {
      mark2[0][l] = mark1[i];
      l++;
    }
  }
  mark2[0][l] = mark1[j-1];

  m[0] = l;
  m[1] = 1;

  while(1) {
  mark2[1][0] = mark2[0][0];
  for(i=1;i<=m[0]-1;i++) {
    s = (inten[mark2[0][i+1]] - inten[mark2[0][i-1]])/
			    (wave[mark2[0][i+1]] - wave[mark2[0][i-1]]);
    if(inten[mark2[0][i]] >= s*(wave[mark2[0][i]] - wave[mark2[0][i-1]]) +
			 inten[mark2[0][i-1]]) {
      mark2[1][m[1]] = mark2[0][i];
      m[1]++;
    }
  }
  mark2[1][m[1]] = mark2[0][m[0]];
  if(m[1] == m[0]) break;
  else {
    for(i=0;i<=m[1];i++) mark2[0][i] = mark2[1][i];
    m[0] = m[1];
    m[1] = 1;
  }
  }

  for(i=0;i<=m[1];i++) {
    xar[i] = wave[mark2[1][i]];
    yar[i] = inten[mark2[1][i]];
  }
  *n = m[1];
  free_ivector(mark1,0,10000);
  free_imatrix(mark2,0,1,0,10000);
  return;
}

int autorectify()
{
  extern double *xar,*yar;
  extern double *wave,*flux;
  extern int nar;
  extern unsigned long nd[20];
  int n,klo,khi,k,i;
  double div;

  k = nd[1];

  n = 0;
  for(i=0;i<k;i++) {
    if(wave[i] <= xar[0]) {
      klo = 0;
      khi = 1;
    } else if(wave[i] > xar[nar-1]) {
      klo = nar - 2;
      khi = nar - 1;
    } else if(wave[i] > xar[n+1]) n++;
    else {
      klo = n;
      khi = n+1;
    }
    div = yar[klo] + (yar[khi]-yar[klo])*(wave[i] - xar[klo])/
	  (xar[khi]-xar[klo]);
    flux[i] /= div;
  }

  return(1);

}


void sautorec(x,y,k,n)
double *x,*y;
int k,*n;
{
  FILE *in,*out;
  double *wave,*inten;
  int *mark1,**mark2;
  int i,j,l,m[2];
  float s;
  extern double *xar,*yar;
  extern unsigned long  nd[20];

  wave = x;
  inten = y;
  mark1 = ivector(0,10000);
  mark2 = imatrix(0,1,0,10000);

  j = 0;
  for(i=1+nd[1];i<k-1+nd[1];i++) {
    if(inten[i] > inten[i-1] && inten[i] >= inten[i+1]) {
      mark1[j] = i;
      j++;
    }
  }

  l = 1;
  mark2[0][0] = mark1[0];
  for(i=1;i<j-1;i++) {
    s = (inten[mark1[i+1]] - inten[mark1[i-1]])/
			    (wave[mark1[i+1]] - wave[mark1[i-1]]);
    if(inten[mark1[i]] > s*(wave[mark1[i]] - wave[mark1[i-1]]) +
			 inten[mark1[i-1]]) {
      mark2[0][l] = mark1[i];
      l++;
    }
  }
  mark2[0][l] = mark1[j-1];

  m[0] = l;
  m[1] = 1;

  while(1) {
  mark2[1][0] = mark2[0][0];
  for(i=1;i<=m[0]-1;i++) {
    s = (inten[mark2[0][i+1]] - inten[mark2[0][i-1]])/
			    (wave[mark2[0][i+1]] - wave[mark2[0][i-1]]);
    if(inten[mark2[0][i]] >= s*(wave[mark2[0][i]] - wave[mark2[0][i-1]]) +
			 inten[mark2[0][i-1]]) {
      mark2[1][m[1]] = mark2[0][i];
      m[1]++;
    }
  }
  mark2[1][m[1]] = mark2[0][m[0]];
  if(m[1] == m[0]) break;
  else {
    for(i=0;i<=m[1];i++) mark2[0][i] = mark2[1][i];
    m[0] = m[1];
    m[1] = 1;
  }
  }

  for(i=0;i<=m[1];i++) {
    xar[i] = wave[mark2[1][i]];
    yar[i] = inten[mark2[1][i]];
  }
  *n = m[1];
  free_ivector(mark1,0,10000);
  free_imatrix(mark2,0,1,0,10000);
  return;
}
