#include <stdlib.h>
void nrerror();

float **matrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
   int i;
   float **m;
   m = (float **) malloc((unsigned) (nrh-nrl+1)*sizeof(float*));
   if (!m) nrerror("allocation failure 1 in matrix()");
   m -= nrl;

   for(i=nrl;i<=nrh;i++) {
      m[i] = (float*) malloc((unsigned) (nch-ncl+1)*sizeof(float));
      if(!m[i]) nrerror("allocation failure 2 in matrix()");
      m[i] -= ncl;
   }
   return m;
}

double **dmatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
   int i;
   double **m;

   m = (double **) malloc((unsigned) (nrh-nrl+1)*sizeof(double*));
   if(!m) nrerror("allocation failure 1 in dmatrix()");
   m -= nrl;

   for(i=nrl;i<=nrh;i++) {
       m[i] = (double *) malloc((unsigned) (nch-ncl+1)*sizeof(double));
       if(!m[i]) nrerror("allocation failure 2 in dmatrix()");
       m[i] -= ncl;
   }
   return m;
}

float **submatrix(a,oldrl,oldrh,oldcl,oldch,newrl,newcl)
float **a;
int oldrl,oldrh,oldcl,oldch,newrl,newcl;
{
   int i,j;
   float **m;

   m = (float **) malloc((unsigned) (oldrh-oldrl+1)*sizeof(float*));
   if (!m) nrerror("allocation failure in submatrix()");
   m -= newrl;

   for(i=oldrl,j=newrl;i<=oldrh;i++,j++) m[j] = a[i]+oldcl-newcl;
   return m;
}

void free_submatrix(b,nrl,nrh,ncl,nch)
int **b;
int nrl,nrh,ncl,nch;
{
   free((char*) (b+nrl));
}


void free_dmatrix(m,nrl,nrh,ncl,nch)
double **m;
int nrl,nrh,ncl,nch;
{
   int i;

   for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
   free((char*) (m+nrl));
}

void free_matrix(m,nrl,nrh,ncl,nch)
float **m;
int nrl,nrh,ncl,nch;
{
   int i;

   for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
   free((char*) (m+nrl));
}

float **cmatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
   int i;
   float **cm;
   if(nrl != 0 || ncl != 0) {
     nrerror("Matrices declared by cmatrix must be zero-offset");
     exit(1);
   }
   cm = (float **) calloc(nrh+1,sizeof(float*));
   if (!cm) nrerror("allocation failure 1 in cmatrix()");

   for(i=0;i<=nrh;i++) {
      cm[i] = (float*) calloc(nch+1,sizeof(float));
      if(!cm[i]) nrerror("allocation failure 2 in cmatrix()");
   }
   return cm;
}

int **imatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
  int i,**m;

  m=(int **) malloc((unsigned) (nrh-nrl+1)*sizeof(int*));
  if(!m) nrerror("Allocation failure 1 in imatrix");
  m -= nrl;

  for(i=nrl;i<=nrh;i++) {
    m[i] = (int *)malloc((unsigned) (nch-ncl+1)*sizeof(int));
    if (!m[i]) nrerror("Allocation failure 2 in imatrix");
    m[i] -= ncl;
  }
  return m;
}

void free_imatrix(m,nrl,nrh,ncl,nch)
int **m;
int nrl,nrh,ncl,nch;
{
  int i;
  for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
  free((char*) (m+nrl));
}
