#include <stdio.h>
#include <fcntl.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
long intdiv();
long mmin(),mmax();
double *dvector();
double clight = 299791.0;
void convolv();

void qvsini(double *x,double *y,int n,double dwave,double vsini,double u)
{
  double teff,logg,MH,vturb,start,wave;
  double *depth;
  double ymax;
  long i,k,npt,low,high,nspace,fs,num,nd;
  unsigned long left,qsize;
  double scale,space,sum1,sum2,a,z,Ds,n1,n2,ss;
  double l,d;
  double s2,st,dw;
  double *ys;
  char name[15],tmp1[10];

  if(vsini == 0.0) return;

  num = n;

  ys = dvector(1,n);
  depth = y-1;  

  start = x[0];

  s2 = (start+num*dwave)*vsini/(dwave*clight);
  nd = s2 + 5.5;

  convolv(depth,ys,num,nd,start,dwave,vsini,u);

  ymax = 0.0;
  for(i=1;i<=n;i++) {
    if(ymax < ys[i]) ymax = ys[i];
  }
  for(i=1;i<=n;i++) ys[i] /= ymax;

  for(i=0;i<n;i++) y[i] = ys[i+1];
  free_dvector(ys,1,n);
  return;

}

void convolv(y,ys,num,nd,st,dw,vsini,u)
double *y,*ys;
double st,dw,vsini,u;
long num,nd;
{
  double beta,w,s,t,dlc,c1,c2,dv,r1,r2,f,v;
  long i,n1,n2,n;
  char tmp[10];

  beta = (1.0-u)/(1.0 - 0.333333*u);
  
/* End Effect */

  n1 = nd + 1;
  for(i=1;i<=nd;i++) ys[i] = y[i];
  n2 = num - nd -1;
  for(i=n2;i<=num;i++) ys[i] = y[i];
  if(vsini < 0.5) {
    for(i=1;i<=num;i++) ys[i] = y[i];
    return;
  }

/* convolve with rotation profile */

   w = st + (n1-1)*dw;
   for(n=n1;n<=n2;n++) {
     w = w+dw;
     s = 0.0;
     t = 0.0;
     dlc = w*vsini/clight;
     c1 = 0.63661977*beta/dlc;
     c2 = 0.5*beta/dlc;
     dv = dw/dlc;

     for(i=-nd;i<=nd;i++) {
       v = i*dv;
       r2 = 1.0 - v*v;
       if(r2 > 0.0) {
         f = c1*sqrt(r2) + c2*r2;
         t = t+f;
         s = s + f*y[n+i];
       }
     }
     ys[n] = s/t;
   }
   return;
}
