#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <time.h>
#include "xwins.h"
#include "app_glob.c"

/* Modified May 15, 2009 */

char *quit_label = "Quit";
char *load_label = "Load";
char *right_label = "==>";
char *left_label = "<==";
char *zoomin_label = "Zoom In";
char *zoomout_label = "Zoom Out";
char *plus_label = "+";
char *minus_label = "-";
char *reset_label = "Reset Scale";
char *Right_label = ">";
char *RRight_label = ">>";
char *Left_label = "<";
char *LLeft_label = "<<";
char *record_label = "Record";
char *file_label = "<-File";
char *dot_label = "Dot Toggle";
char *up_label = "^";
char *down_label = "v";
char *restore_label = "<-Restore";
char *redraw_label = "Redraw";
char Rfile[80];
char *ggets(char *s);
FILE *rf;
Window RES;
Window RES2;
Window DL;
Window STR;
Window STR2;
Window SKEW;
Window WGT;
Window WGT2;
Window EQW;
Window EQW2;
Window VSINI;
Window VSINI2;
Window MID;
double *wave,*flux;
int *iwave,*iflux;
int flagc = 0;
char head[100][132];
int nh = 0;
int npp = 0;
int x1=100,Y1=650,x2=1000,y2=50;
double xlow=3800.0,xhigh=4600.0,ylow=0.0,yhigh=1.2;
double xl=3800.0,yl=0.0;
double nxlow,nxhigh,nylow,nyhigh;
double space = 0.005;
char infile[300];
char *fname[10];
unsigned long nd[20];
unsigned long size = 1800000;
int file_flag = 0;
XWMHints  xwmh;
XColor White,Green,Red,Grey,Orange,Yellow,Black,Blue,exact;
Colormap default_cmap;

void initapp(int,char **,int,int,unsigned,unsigned);
int findfiles();
int quit_action(caddr_t);
int load_action(caddr_t);
int right_action(caddr_t);
int left_action(caddr_t);
int zoomin_action(caddr_t);
int zoomout_action(caddr_t);
int plus_action(caddr_t);
int minus_action(caddr_t);
int reset_action(caddr_t);
int rleft_action(caddr_t);
int rlleft_action(caddr_t);
int rright_action(caddr_t);
int rrright_action(caddr_t);
int r2left_action(caddr_t);
int r2lleft_action(caddr_t);
int r2right_action(caddr_t);
int r2rright_action(caddr_t);
int sleft_action(caddr_t);
int slleft_action(caddr_t);
int sright_action(caddr_t);
int srright_action(caddr_t);
int s2left_action(caddr_t);
int s2lleft_action(caddr_t);
int s2right_action(caddr_t);
int s2rright_action(caddr_t);
int skleft_action(caddr_t);
int sklleft_action(caddr_t);
int skright_action(caddr_t);
int skrright_action(caddr_t);
int dleft_action(caddr_t);
int dlleft_action(caddr_t);
int dright_action(caddr_t);
int drright_action(caddr_t);
int wleft_action(caddr_t);
int wlleft_action(caddr_t);
int wright_action(caddr_t);
int wrright_action(caddr_t);
int w2left_action(caddr_t);
int w2lleft_action(caddr_t);
int w2right_action(caddr_t);
int w2rright_action(caddr_t);
int vleft_action(caddr_t);
int vlleft_action(caddr_t);
int vright_action(caddr_t);
int vrright_action(caddr_t);
int v2left_action(caddr_t);
int v2lleft_action(caddr_t);
int v2right_action(caddr_t);
int v2rright_action(caddr_t);
int record_action(caddr_t);
int file_action(caddr_t);
int dot_action(caddr_t);
int up_action(caddr_t);
int down_action(caddr_t);
int restore_action(caddr_t);
int redraw_action(caddr_t);
void xaxis();
void labels();
void xplot();
void xplotr();
void scMaxInterval();
void loadspectrum();
void bullet();
void bullets();
void dot();
void addprofile();
double *dvector();
double linespread(double x,double xmid,double w,double s,double wt,double sk);
double profile(double w,double s,double wt);
double linespread2(double x,double xmid,double w,double s,double wt);
double profile2(double w,double s,double wt);
double eqwdth(double *wave,double *flux);
double eqwdth2(double *wave,double *flux);
void qvsini(double *x,double *y,int n,double dwave,double vsini,double u);
float erff(float x);
float sign(float x);

unsigned long *lvector(long nl,long nh);
void free_dvector();
void Drawline();
int InBetween();
void indexx(unsigned long n, double arr[], unsigned long indx[]);
Window Pos;
Window Shf;
char title[100];
Cursor crosshair;
Cursor Circle;
Cursor downarrow;
unsigned fontheight;
unsigned long *indx;
double dw;
int n,nf;
int xtics,ytics,nxtics,nytics;
double Res = 0.10;
double Str = 0.50;
double Wgt = 0.0;
double vsini = 0.0;
double sk = 0.0;
double mid = 0.0;
double eqw = 0.0;
double eqw2 = 0.0;
double dl = 0.000;
double Res2 = 0.10;
double Str2 = 0.20;
double Wgt2 = 0.0;
double vsini2 = 0.0;
double cont = 1.000;
int offset = 0;
int flagdot = 0;
char sres[20];
char sstr[20];
char swgt[20];
char svsini[20];
char smid[20];
char seqw[50];
char seqw2[50];
char ssk[50];
char sdl[50];
char sres2[50];
char sstr2[50];
char swgt2[50];
char svsini2[50];
int sbullet = 0;

main(int arGC, char **argv)
{
  XWIN *QuitButton, *LoadButton, *which_xwin;
  XWIN *ZoomInButton, *ZoomOutButton;
  XWIN *PlusButton, *MinusButton;
  XWIN *ResetButton, *RightButton, *LeftButton;
  XWIN *rLeftButton, *rLLeftButton, *rRightButton, *rRRightButton;
  XWIN *r2LeftButton, *r2LLeftButton, *r2RightButton, *r2RRightButton;
  XWIN *dLeftButton, *dLLeftButton, *dRightButton, *dRRightButton;
  XWIN *sLeftButton, *sLLeftButton, *sRightButton, *sRRightButton;
  XWIN *wLeftButton, *wLLeftButton, *wRightButton, *wRRightButton;
  XWIN *w2LeftButton, *w2LLeftButton, *w2RightButton, *w2RRightButton;
  XWIN *vLeftButton, *vLLeftButton, *vRightButton, *vRRightButton;
  XWIN *v2LeftButton, *v2LLeftButton, *v2RightButton, *v2RRightButton;
  XWIN *skLeftButton, *skLLeftButton, *skRightButton, *skRRightButton;
  XWIN *s2LeftButton, *s2LLeftButton, *s2RightButton, *s2RRightButton;
  XWIN *RecordButton, *FileButton, *UpButton, *DownButton;
  XWIN *RestoreButton, *DotButton, *RedrawButton;

  unsigned quit_width, quit_height, load_width;
  unsigned xscale_width, right_width, left_width;
  unsigned zoomin_width, zoomout_width, redraw_width;
  unsigned plus_width,minus_width,dot_width;
  unsigned reset_width,up_width,down_width,restore_width;
  unsigned LLwidth,Lwidth,Rwidth,RRwidth,Recwidth,Fwidth;
  FILE *in;
  int i,j,k;
  int xs,xe,xs1,xs2,xe1,xe2;
  double dxw,dyw,xcen;
  char tmp1[80],tmp2[80];

  wave = (double *) calloc(size,sizeof(double));
  flux = (double *) calloc(size,sizeof(double));
  iwave = (int *) calloc(size,sizeof(int));
  iflux = (int *) calloc(size,sizeof(int));

  printf("\n\nXEQW3b  (C) Richard O. Gray 2008,2009 \n\n");

  printf("\nEnter name of spectrum files > ");
  ggets(infile);
  loadspectrum();
  printf("Spectrum loaded\n");  

  xwin_init();

  initapp(arGC,argv,10,10,1000,640);
  x1 = 250;
  x2 = 1000 - 25;
  Y1 = 640 - 75;
  y2 = 75;

  quit_width = XTextWidth(theFontStruct,quit_label,strlen(quit_label)) + 4;
  quit_height = theFontStruct->max_bounds.ascent +
		theFontStruct->max_bounds.descent + 4;
  fontheight = quit_height - 4;
  QuitButton = MakeXButton(1,1,quit_width,quit_height,1,theFGpix,theBGpix,
	       theMain,quit_label,quit_action,NULL);
  load_width = XTextWidth(theFontStruct,load_label,strlen(load_label)) +4;
  LoadButton = MakeXButton(quit_width+4,1,load_width,quit_height,1,
               theFGpix,theBGpix,theMain,load_label,load_action,NULL);
  right_width = XTextWidth(theFontStruct,right_label,
                            strlen(right_label)) +4;
  RightButton = MakeXButton(quit_width+load_width+8,
              1,right_width,quit_height,1,theFGpix,theBGpix,
              theMain,right_label,right_action,NULL);
  left_width = XTextWidth(theFontStruct,left_label,
                            strlen(left_label)) +4;
  LeftButton = MakeXButton(quit_width+load_width+
              right_width+12,1,left_width,quit_height,1,theFGpix,
              theBGpix,theMain,left_label,left_action,NULL);
  zoomin_width = XTextWidth(theFontStruct,zoomin_label,
                            strlen(zoomin_label)) +4;
  ZoomInButton = MakeXButton(quit_width+load_width+
              right_width+left_width+16,1,zoomin_width,
              quit_height,1,theFGpix,theBGpix,theMain,zoomin_label,
              zoomin_action,NULL);
  zoomout_width = XTextWidth(theFontStruct,zoomout_label,
                            strlen(zoomout_label)) +4;
  ZoomOutButton = MakeXButton(quit_width+load_width+
              right_width+left_width+zoomin_width+20,1,zoomout_width,
              quit_height,1,theFGpix,theBGpix,theMain,zoomout_label,
              zoomout_action,NULL);
  Recwidth = XTextWidth(theFontStruct,record_label,strlen(record_label))+4;
  RecordButton = MakeXButton(quit_width+load_width+right_width+left_width+
              zoomin_width+zoomout_width+24,1,Recwidth,quit_height,1,theFGpix,
               theBGpix,theMain,record_label,record_action,NULL);
  Fwidth = XTextWidth(theFontStruct,file_label,strlen(file_label))+4;
  FileButton = MakeXButton(quit_width+load_width+right_width+left_width+
              zoomin_width+zoomout_width+Recwidth+28,1,Fwidth,quit_height,
              1,theFGpix,theBGpix,theMain,file_label,file_action,NULL);
  dot_width =  XTextWidth(theFontStruct,dot_label,strlen(dot_label))+4;
  DotButton = MakeXButton(quit_width+load_width+right_width+left_width+
              zoomin_width+zoomout_width+Recwidth+Fwidth+32,1,dot_width,
              quit_height,1,theFGpix,theBGpix,theMain,dot_label,dot_action,
              NULL); 

  plus_width = XTextWidth(theFontStruct,plus_label,strlen(plus_label)) +4;
  PlusButton = MakeXButton(1,quit_height+4,plus_width,quit_height,1,
               theFGpix,theBGpix,theMain,plus_label,plus_action,NULL);
  MinusButton = MakeXButton(plus_width+4,quit_height+4,plus_width,
               quit_height,1,theFGpix,theBGpix,theMain,minus_label,
               minus_action,NULL);
  reset_width = XTextWidth(theFontStruct,reset_label,strlen(reset_label))+4;
  ResetButton = MakeXButton(2*plus_width+8,quit_height+4,reset_width, 
               quit_height,1,theFGpix,theBGpix,theMain,reset_label,
               reset_action,NULL);
  up_width = XTextWidth(theFontStruct,up_label,strlen(up_label)) +4;
  UpButton = MakeXButton(2*plus_width+reset_width+12,quit_height+4,
               up_width,quit_height,1,theFGpix,theBGpix,theMain,up_label,
               up_action,NULL);
  down_width = XTextWidth(theFontStruct,down_label,strlen(down_label)) +4;
  DownButton = MakeXButton(2*plus_width+reset_width+up_width+16,quit_height+4,
               down_width,quit_height,1,theFGpix,theBGpix,theMain,down_label,
               down_action,NULL);
  restore_width = XTextWidth(theFontStruct,restore_label,
               strlen(restore_label)) +4;
  RestoreButton = MakeXButton(2*plus_width+reset_width+up_width+down_width+20,
               quit_height+4,restore_width,quit_height,1,theFGpix,theBGpix,
               theMain,restore_label,restore_action,NULL);
  redraw_width = XTextWidth(theFontStruct,redraw_label,
               strlen(redraw_label)) +4;
  RedrawButton = MakeXButton(2*plus_width+reset_width+up_width+down_width+
               restore_width+24,quit_height+4,redraw_width,quit_height,1,
               theFGpix,theBGpix,theMain,redraw_label,redraw_action,NULL);


  LLwidth = XTextWidth(theFontStruct,LLeft_label,strlen(LLeft_label))+4;
  Lwidth = XTextWidth(theFontStruct,Left_label,strlen(Left_label))+4;
  Rwidth = XTextWidth(theFontStruct,Right_label,strlen(Right_label))+4;
  RRwidth = XTextWidth(theFontStruct,RRight_label,strlen(RRight_label))+4;
  rLLeftButton = MakeXButton(10,85,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,rlleft_action,NULL);
  rLeftButton = MakeXButton(10+LLwidth+4,85,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,rleft_action,NULL);
  rRightButton = MakeXButton(10+LLwidth+Lwidth+8,85,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,rright_action,NULL);
  rRRightButton = MakeXButton(10+LLwidth+Lwidth+Rwidth+12,85,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                rrright_action,NULL);
  dLLeftButton = MakeXButton(110,85,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,dlleft_action,NULL);
  dLeftButton = MakeXButton(110+LLwidth+4,85,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,dleft_action,NULL);
  dRightButton = MakeXButton(110+LLwidth+Lwidth+8,85,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,dright_action,NULL);
  dRRightButton = MakeXButton(110+LLwidth+Lwidth+Rwidth+12,85,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                drright_action,NULL);
 
  wLLeftButton = MakeXButton(10,150,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,wlleft_action,NULL);
  wLeftButton = MakeXButton(10+LLwidth+4,150,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,wleft_action,NULL);
  wRightButton = MakeXButton(10+LLwidth+Lwidth+8,150,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,wright_action,NULL);
  wRRightButton = MakeXButton(10+LLwidth+Lwidth+Rwidth+12,150,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                wrright_action,NULL);
  r2LLeftButton = MakeXButton(110,150,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,r2lleft_action,NULL);
  r2LeftButton = MakeXButton(110+LLwidth+4,150,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,r2left_action,NULL);
  r2RightButton = MakeXButton(110+LLwidth+Lwidth+8,150,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,r2right_action,NULL);
  r2RRightButton = MakeXButton(110+LLwidth+Lwidth+Rwidth+12,150,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                r2rright_action,NULL);
 
  vLLeftButton = MakeXButton(10,215,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,vlleft_action,NULL);
  vLeftButton = MakeXButton(10+LLwidth+4,215,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,vleft_action,NULL);
  vRightButton = MakeXButton(10+LLwidth+Lwidth+8,215,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,vright_action,NULL);
  vRRightButton = MakeXButton(10+LLwidth+Lwidth+Rwidth+12,215,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                vrright_action,NULL);
  w2LLeftButton = MakeXButton(110,215,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,w2lleft_action,NULL);
  w2LeftButton = MakeXButton(110+LLwidth+4,215,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,w2left_action,NULL);
  w2RightButton = MakeXButton(110+LLwidth+Lwidth+8,215,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,w2right_action,NULL);
  w2RRightButton = MakeXButton(110+LLwidth+Lwidth+Rwidth+12,215,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                w2rright_action,NULL);

 
  sLLeftButton = MakeXButton(10,280,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,slleft_action,NULL);
  sLeftButton = MakeXButton(10+LLwidth+4,280,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,sleft_action,NULL);
  sRightButton = MakeXButton(10+LLwidth+Lwidth+8,280,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,sright_action,NULL);
  sRRightButton = MakeXButton(10+LLwidth+Lwidth+Rwidth+12,280,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                srright_action,NULL);
  vLLeftButton = MakeXButton(110,280,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,v2lleft_action,NULL);
  vLeftButton = MakeXButton(110+LLwidth+4,280,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,v2left_action,NULL);
  vRightButton = MakeXButton(110+LLwidth+Lwidth+8,280,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,v2right_action,NULL);
  vRRightButton = MakeXButton(110+LLwidth+Lwidth+Rwidth+12,280,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                v2rright_action,NULL);


  s2LLeftButton = MakeXButton(110,345,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,s2lleft_action,NULL);
  s2LeftButton = MakeXButton(110+LLwidth+4,345,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,s2left_action,NULL);
  s2RightButton = MakeXButton(110+LLwidth+Lwidth+8,345,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,s2right_action,NULL);
  s2RRightButton = MakeXButton(110+LLwidth+Lwidth+Rwidth+12,345,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                s2rright_action,NULL);

 
  skLLeftButton = MakeXButton(10,345,LLwidth,quit_height,1,theFGpix,theBGpix,
		theMain,LLeft_label,sklleft_action,NULL);
  skLeftButton = MakeXButton(10+LLwidth+4,345,Lwidth,quit_height,1,theFGpix,
                theBGpix,theMain,Left_label,skleft_action,NULL);
  skRightButton = MakeXButton(10+LLwidth+Lwidth+8,345,Rwidth,quit_height,1,
                theFGpix,theBGpix,theMain,Right_label,skright_action,NULL);
  skRRightButton = MakeXButton(10+LLwidth+Lwidth+Rwidth+12,345,RRwidth,
                quit_height,1,theFGpix,theBGpix,theMain,RRight_label,
                skrright_action,NULL); 



  default_cmap=DefaultColormap(theDisplay,DefaultScreen(theDisplay));
  XAllocNamedColor(theDisplay,default_cmap,"red",&exact,&Red);
  XAllocNamedColor(theDisplay,default_cmap,"green",&exact,&Green);
  XAllocNamedColor(theDisplay,default_cmap,"grey40",&exact,&Grey);
  XAllocNamedColor(theDisplay,default_cmap,"white",&exact,&White); 
  XAllocNamedColor(theDisplay,default_cmap,"orange",&exact,&Orange);
  XAllocNamedColor(theDisplay,default_cmap,"yellow",&exact,&Yellow); 
  XAllocNamedColor(theDisplay,default_cmap,"black",&exact,&Black);
  XAllocNamedColor(theDisplay,default_cmap,"blue",&exact,&Blue); 


  XSelectInput(theDisplay,theMain,ExposureMask|PointerMotionMask|
     ButtonPressMask|OwnerGrabButtonMask|ButtonReleaseMask|
     ButtonMotionMask);

  RES = XCreateSimpleWindow(theDisplay,theMain,10,105,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,RES);

  DL = XCreateSimpleWindow(theDisplay,theMain,110,105,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,DL);

  RES2 = XCreateSimpleWindow(theDisplay,theMain,110,170,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,RES2);

  WGT = XCreateSimpleWindow(theDisplay,theMain,10,170,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,WGT);

  WGT2 = XCreateSimpleWindow(theDisplay,theMain,110,235,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,WGT2);

  VSINI = XCreateSimpleWindow(theDisplay,theMain,10,235,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,VSINI);  

  VSINI2 = XCreateSimpleWindow(theDisplay,theMain,110,300,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,VSINI2); 

  STR = XCreateSimpleWindow(theDisplay,theMain,10,300,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,STR);

  STR2 = XCreateSimpleWindow(theDisplay,theMain,110,365,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,STR2);

  SKEW = XCreateSimpleWindow(theDisplay,theMain,10,365,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,SKEW);  

  Pos = XCreateSimpleWindow(theDisplay,theMain,x1,Y1+35,150,
         2*fontheight+8,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,Pos);

  EQW = XCreateSimpleWindow(theDisplay,theMain,10,415,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,EQW);

  EQW2 = XCreateSimpleWindow(theDisplay,theMain,110,415,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,EQW2);

  MID = XCreateSimpleWindow(theDisplay,theMain,10,515,100,
         2*fontheight,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,MID);
  

  crosshair = XCreateFontCursor(theDisplay,XC_tcross);
  Circle = XCreateFontCursor(theDisplay,XC_circle);
  downarrow = XCreateFontCursor(theDisplay,XC_sb_down_arrow);
  XDefineCursor(theDisplay,theMain,crosshair);

  XClearWindow(theDisplay,theMain);
  labels();

  dw = (wave[3] - wave[1])/8.0;

 while(!AppDone) {
    XNextEvent(theDisplay,&theEvent);
    if(theEvent.xany.window == theMain) {
      switch(theEvent.type) {
        case Expose:
          if(theEvent.xexpose.count == 0) {
	    int itemp;
	    unsigned int width,height,utemp;
	    Window wtemp;
	    if(XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
	       &width,&height,&utemp,&utemp) == 0) break;
	    x1 = 250;
	    x2 = width - 25;
	    Y1 = height - 75;
	    y2 = 75;
            XMoveWindow(theDisplay,Pos,x1,Y1+35);
	    profile(Res,Str,Wgt);
            qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
            if(sbullet == 1) {
              profile2(Res2,Str2,Wgt2);
              qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
              addprofile();
            }
	    for(i=0;i<nd[nf];i++) {
	     iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
	     iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
	     if(i >= nd[1]) iflux[i] += offset;
	    }
	    XClearWindow(theDisplay,theMain);
	    xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
	    xplot(iwave,iflux);
	    labels();
          }
          break;

        case MotionNotify: {
            Window rw,cw;
            int xr,yr,xw,yw,kbstat;
            XQueryPointer(theDisplay,theEvent.xmotion.window,
              &rw,&cw,&xr,&yr,&xw,&yw,&kbstat);
            dxw = xlow + (double)(xw-x1)*(xhigh-xlow)/(double)(x2-x1);
            dyw = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
            sprintf(tmp1,"x = %12.7g",dxw);
            sprintf(tmp2,"y = %12.6g",dyw);
            XClearWindow(theDisplay,Pos);
	    labels();
            if(xw >= x1 && xw <= x2 && yw >= y2 && yw <= Y1) {
              XDrawString(theDisplay,Pos,theGC,1,fontheight,
                tmp1,strlen(tmp1));
              XDrawString(theDisplay,Pos,theGC,1,2*fontheight+2,      
                tmp2,strlen(tmp2));
            }
            break;
	}

      case ButtonPress: {
        switch(theEvent.xbutton.button) {
	case Button1: {
	  Window rw,cw;
	  int xr,yr,xw,yw,kbstat;
	  XQueryPointer(theDisplay,theEvent.xmotion.window,
           &rw,&cw,&xr,&yr,&xw,&yw,&kbstat);
	  if(xw > 171 && xw < 179 && yw > 51 && yw < 59) {
	    if(sbullet == 0) sbullet = 1;
	    else sbullet = 0;
	  }
	  if(sbullet == 1) nf = 4;
	  if(sbullet == 0) nf = 2;
	  bullets();
	  break;
	}
	}
      }


      }
    }
    if(XFindContext(theDisplay,theEvent.xany.window,xwin_context,
       (caddr_t *) &which_xwin) == 0) {
       if(*(which_xwin->event_handler) != NULL)
	 (*(which_xwin->event_handler))(which_xwin);
    }
 }
  XCloseDisplay(theDisplay);
  exit(0);
}

int quit_action(caddr_t data)
{
  AppDone = 1;
  if(file_flag == 1) fclose(rf);
  return 1;
}

int load_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;

  dl = 0.000;
 
  XUndefineCursor(theDisplay,theMain);   
  XDefineCursor(theDisplay,theMain,crosshair);


  printf("\nEnter new spectrum file > ");
  ggets(infile);
  while(findfiles(infile) != 0) {
   printf("\nEnter name of spectrum file > ");
   ggets(infile);
  }

  loadspectrum();
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh + xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

int reset_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  xlow = xhigh = wave[0];
  ylow = yhigh = flux[0];
  for(i=0;i<nd[nf];i++) {
    if(xlow > wave[i]) xlow = wave[i];
    if(xhigh < wave[i]) xhigh = wave[i];
    if(ylow > flux[i]) ylow = flux[i];
    if(yhigh < flux[i]) yhigh = flux[i];
  }
  scMaxInterval(xlow,xhigh,10,&nxlow,&nxhigh,&nxtics);
  scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
  xlow = nxlow;
  xhigh = nxhigh;
  xtics = nxtics;
  ylow = nylow;
  yhigh = nyhigh;
  ytics = nytics;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

int right_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;
  xw = xhigh - xlow;
  xmid = (xhigh + xlow)/2.0;
  xlow = xlow + 0.10*xw;
  xhigh = xhigh + 0.10*xw;
  

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

int left_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;   
  double xmid,xw;   
  
  xw = xhigh - xlow;
  xmid = (xhigh + xlow)/2.0;
  xlow = xlow - 0.10*xw;
  xhigh = xhigh - 0.10*xw;
   
  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250; 
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

int zoomin_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;

  xw = (xhigh - xlow)/1.25;
  xmid = (xhigh + xlow)/2.0;
  xlow = xmid - xw/2.0;
  xhigh = xmid + xw/2.0;


  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

int zoomout_action(caddr_t data)
{ 
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;
  
  xw = 1.25*(xhigh - xlow);
  xmid = (xhigh + xlow)/2.0;
  xlow = xmid - xw/2.0;
  xhigh = xmid + xw/2.0;

  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1; 
}

/*
int plus_action(caddr_t data)
{
  int i;

  for(i=0;i<nd[1];i++) wave[i] += dw;  

  for(i=0;i<nd[1];i++) 
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1; 
}
*/

int plus_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;
  xw = xhigh - xlow;
  xmid = (xhigh + xlow)/2.0;
  xlow = xlow - 0.001*xw;
  xhigh = xhigh - 0.001*xw;
  

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

/*
int minus_action(caddr_t data)
{
  int i;
  
  for(i=0;i<nd[1];i++) wave[i] -= dw;
  
  for(i=0;i<nd[1];i++)
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}
*/

int minus_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;   
  double xmid,xw;   
  
  xw = xhigh - xlow;
  xmid = (xhigh + xlow)/2.0;
  xlow = xlow + 0.001*xw;
  xhigh = xhigh + 0.001*xw;
   
  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250; 
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

int color_action(caddr_t data)
{
  if(flagc == 0) flagc = 1;
  else flagc = 0;

  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

void xplot(iwave,iflux)
int *iwave,*iflux;
{
  int i,j,k;


  for(j=0;j<nf;j++) {
    if(flagc == 1 && j%5 == 0) XSetForeground(theDisplay,theGC,White.pixel);
    if(flagc == 1 && j%5 == 1) XSetForeground(theDisplay,theGC,Red.pixel);
    if(flagc == 1 && j%5 == 2) XSetForeground(theDisplay,theGC,Orange.pixel);
    if(flagc == 1 && j%5 == 3) XSetForeground(theDisplay,theGC,Yellow.pixel);
    if(flagc == 1 && j%5 == 4) XSetForeground(theDisplay,theGC,Green.pixel);
    if(j == 0)
         XSetForeground(theDisplay,theGC,White.pixel);
    if(j == 1 && offset == 0)
         XSetForeground(theDisplay,theGC,Green.pixel);
    if(j == 1 && offset != 0)
         XSetForeground(theDisplay,theGC,Orange.pixel);
    if(j == 2)
         XSetForeground(theDisplay,theGC,Blue.pixel);
    if(j == 3) 
         XSetForeground(theDisplay,theGC,Red.pixel);
    for(i=nd[j];i<nd[j+1]-1;i++) {
      Drawline(iwave[i],iflux[i],iwave[i+1],iflux[i+1]);
      if(flagdot == 1 && j == 0 && iwave[i] >= x1 && iwave[i] <= x2) 
          dot(iwave[i],iflux[i]);
    }
  }
  XSetForeground(theDisplay,theGC,White.pixel);
}

void Drawline(iw1,ifx1,iw2,ifx2)
int iw1,iw2,ifx1,ifx2;
{
  int xmid,ymid,fx1,fx2,fy1,fy2;
  int xrange,yrange;
  int n,yL,yH,xL,xH;

  xrange = abs(x2-x1)/2;
  yrange = abs(Y1-y2)/2;
  xmid = (x1 + x2)/2.0;
  ymid = (Y1 + y2)/2.0;

  fx1 = abs(iw1-xmid);
  fx2 = abs(iw2-xmid);
  fy1 = abs(ifx1-ymid);
  fy2 = abs(ifx2-ymid);

  if(iw1 == x1 && iw2 == x2 && ((Y1 == y2 == 0) || (ifx1 == Y1 && ifx2 == y2)))
  {
    XDrawLine(theDisplay,theMain,theGC,iw1,ifx1,iw2,ifx2);
    return;
  }
  if(fy1 <= yrange && fy2 <= yrange) {
    if(fx1 <= xrange && fx2 <= xrange) {
      XDrawLine(theDisplay,theMain,theGC,iw1,ifx1,iw2,ifx2);
      return;
    }
    if(fx1 > xrange && fx2 > xrange) return;
    if((n = InBetween(iw1,x1,iw2)) == 1 && fx1 > xrange && iw2 != iw1) {
      yL = ifx1 + (ifx2-ifx1)*(x1-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x1,yL,iw2,ifx2);
      return;
    }
    if((n = InBetween(iw1,x1,iw2)) == 1 && fx1 <= xrange && iw2 != iw1) {
      yL = ifx1 + (ifx2-ifx1)*(x1-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x1,yL,iw1,ifx1);
      return;
    }
    if((n = InBetween(iw1,x2,iw2)) == 1 && fx2 > xrange && iw2 != iw1) {
      yH = ifx1 + (ifx2-ifx1)*(x2-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x2,yH,iw1,ifx1);
      return;
    }
    if((n = InBetween(iw1,x2,iw2)) == 1 && fx2 <= xrange && iw2 != iw1) {
      yH = ifx1 + (ifx2-ifx1)*(x2-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x2,yH,iw2,ifx2);
      return;
    }
  }
  if(fy1 > yrange && fy2 > yrange) return;
  if((n = InBetween(ifx2,Y1,ifx1)) == 1 && fy1 > yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xL = iw1 + (iw2-iw1)*(Y1-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xL,Y1,iw2,ifx2);
      return;
  }
  if((n = InBetween(ifx2,Y1,ifx1)) == 1 && fy1 <= yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xL = iw1 + (iw2-iw1)*(Y1-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xL,Y1,iw1,ifx1);
      return;
  }
  if((n = InBetween(ifx2,y2,ifx1)) == 1 && fy1 <= yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xH = iw1 + (iw2-iw1)*(y2-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xH,y2,iw1,ifx1);
      return;
  }
  if((n = InBetween(ifx2,y2,ifx1)) == 1 && fy1 > yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xH = iw1 + (iw2-iw1)*(y2-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xH,y2,iw2,ifx2);
      return;
  }
  return;
}

int InBetween(x0,x1,x2)
int x0,x1,x2;
{
  if(x1 > x0 && x1 > x2) return(0);
  if(x1 < x0 && x1 < x2) return(0);
  if(x0 == x2) return(0);
  return(1);
}

void loadspectrum()
{
 int i,j;
 FILE *in;
 char tmp[20],tmp1[50];
 double offset;

 while(findfiles(infile) != 0) {
   printf("\nEnter name of spectrum files > ");
   ggets(infile);            
 }
 strcpy(title,infile);
 
 nf = 0;
 fname[0] = strtok(infile,"+ ");
 for(i=1;i<9;i++) {
    if((fname[i] = strtok(NULL,"+ ")) == NULL) {  
      nf = i;
      break;
    }
 }
 nd[0] = 0;
 for(i=0;i<nf;i++) {
    if(mkgrab(fname[i],wave,flux,1,2,i) == 0) {
      nf = i;
      break;
    }
 }
 offset = 0.0;
 if(nf > 1) {
   printf("\nEnter offset > ");
   ggets(tmp);
   offset = atof(tmp);
 }
 /* printf("nf = %d  nd[nf] = %d\n",nf,nd[nf]); */

 if(nf > 1) {
   for(j=1;j<nf;j++) {
     for(i=nd[j];i<nd[j+1];i++) 
       flux[i] -= offset*(double)j;
   }
 }


 xlow = xhigh = wave[0];
 ylow = yhigh = flux[0];
 for(i=0;i<nd[nf];i++) {
    if(xlow > wave[i]) xlow = wave[i];
    if(xhigh < wave[i]) xhigh = wave[i];
    if(ylow > flux[i]) ylow = flux[i];
    if(yhigh < flux[i]) yhigh = flux[i];
 }
 scMaxInterval(xlow,xhigh,10,&nxlow,&nxhigh,&nxtics);
 scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
 xlow = nxlow;
 xhigh = nxhigh;
 xtics = nxtics;
 ylow = nylow;
 yhigh = nyhigh;
 ytics = nytics;
 mid = (xhigh+xlow)/2.0;
 sprintf(smid,"%9.3f A",mid);
 profile(Res,Str,Wgt);
 qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
 if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
 }
 for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
 }
}

void labels()
{
  XDrawString(theDisplay,theMain,theGC,10,60,"Primary",
              strlen("Primary"));
  XDrawString(theDisplay,theMain,theGC,10,78,"FWHM",
              strlen("FWHM"));
  XDrawString(theDisplay,theMain,theGC,110,60,"Secondary",
              strlen("Secondary"));
  XDrawString(theDisplay,theMain,theGC,110,78,"Delta Lambda",
              strlen("Delta Lambda"));
  bullet(175,55);
  XDrawString(theDisplay,theMain,theGC,10,143,"Wings",strlen("Wings"));
  XDrawString(theDisplay,theMain,theGC,110,143,"FWHM2",strlen("FWHM2"));
  XDrawString(theDisplay,theMain,theGC,10,208,"Rotation",strlen("Rotation"));
  XDrawString(theDisplay,theMain,theGC,110,208,"Wings2",strlen("Wings2"));
  XDrawString(theDisplay,theMain,theGC,10,273,"Depth",strlen("Depth"));
  XDrawString(theDisplay,theMain,theGC,110,273,"Rotation2",strlen("Rotation2"));
  XDrawString(theDisplay,theMain,theGC,10,338,"Skew",strlen("Skew"));
  XDrawString(theDisplay,theMain,theGC,110,338,"Depth2",strlen("Depth2"));
  XClearWindow(theDisplay,RES);
  XClearWindow(theDisplay,RES2);
  XClearWindow(theDisplay,DL);
  XClearWindow(theDisplay,WGT);
  XClearWindow(theDisplay,WGT2);
  XClearWindow(theDisplay,VSINI);
  XClearWindow(theDisplay,VSINI2);
  XClearWindow(theDisplay,STR);
  XClearWindow(theDisplay,STR2);
  XClearWindow(theDisplay,EQW);
  XClearWindow(theDisplay,EQW2);
  XClearWindow(theDisplay,MID);
  XClearWindow(theDisplay,SKEW);
  sprintf(sres,"%6.3fA",Res);
  sprintf(swgt,"%6.2f",Wgt);
  sprintf(swgt2,"%6.2f",Wgt2);
  sprintf(svsini,"%4.1f km/s",vsini);
  sprintf(svsini2,"%4.1f km/s",vsini2);
  sprintf(sstr,"%6.3f",Str);
  sprintf(sstr2,"%6.3f",Str2);
  sprintf(ssk,"%6.3f",sk);
  sprintf(sdl,"%7.3fA",dl);
  sprintf(sres2,"%6.3fA",Res2);
  XDrawString(theDisplay,SKEW,theGC,1,fontheight,ssk,strlen(ssk));
  XDrawString(theDisplay,DL,theGC,1,fontheight,sdl,strlen(sdl));
  XDrawString(theDisplay,RES,theGC,1,fontheight,sres,strlen(sres));
  XDrawString(theDisplay,RES2,theGC,1,fontheight,sres2,strlen(sres2));
  XDrawString(theDisplay,STR,theGC,1,fontheight,sstr,strlen(sstr));
  XDrawString(theDisplay,STR2,theGC,1,fontheight,sstr2,strlen(sstr2));
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  XDrawString(theDisplay,WGT2,theGC,1,fontheight,swgt2,strlen(swgt2));
  XDrawString(theDisplay,VSINI,theGC,1,fontheight,svsini,strlen(svsini));
  XDrawString(theDisplay,VSINI2,theGC,1,fontheight,svsini2,strlen(svsini2));
  XDrawString(theDisplay,SKEW,theGC,1,fontheight,ssk,strlen(ssk));
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
  XDrawString(theDisplay,MID,theGC,1,fontheight,smid,strlen(smid));
  bullets();
}

void bullets()
{
  bullet(175,55);
  if(sbullet == 1) dot(175,55);
  if(sbullet == 0) {
    XSetForeground(theDisplay,theGC,Black.pixel);
    dot(175,55);
    XSetForeground(theDisplay,theGC,White.pixel);
  }
  if(sbullet == 1) nf = 4;
  if(sbullet == 0) nf = 2;

}

int rlleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res -= 0.1;
  if(Res < 0.01) Res = 0.01;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    eqw2 = eqwdth2(wave,flux);
    XClearWindow(theDisplay,EQW);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,RES);
  sprintf(sres,"%6.3fA",Res);
  XDrawString(theDisplay,RES,theGC,1,fontheight,sres,strlen(sres)); 
  labels();
  return 1;
}

int rleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res -= 0.001;
  if(Res < 0.01) Res = 0.01;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    XClearWindow(theDisplay,EQW);
    eqw2 = eqwdth2(wave,flux);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,RES);
  sprintf(sres,"%6.3fA",Res);
  XDrawString(theDisplay,RES,theGC,1,fontheight,sres,strlen(sres));
  labels();
  return 1;
}

int rrright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res += 0.1;
  if(Res > 20.0) Res = 20.0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    XClearWindow(theDisplay,EQW);
    eqw2 = eqwdth2(wave,flux);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,RES);
  sprintf(sres,"%6.3fA",Res);
  XDrawString(theDisplay,RES,theGC,1,fontheight,sres,strlen(sres));
  labels();
  return 1;
}

int rright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res += 0.001;
  if(Res > 20.0) Res = 20.0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    XClearWindow(theDisplay,EQW);
    eqw2 = eqwdth2(wave,flux);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,RES);
  sprintf(sres,"%6.3fA",Res);
  XDrawString(theDisplay,RES,theGC,1,fontheight,sres,strlen(sres));
  labels();
  return 1;
}

int dlleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  dl -= 0.05;

  if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,DL);
  sprintf(sdl,"%7.3fA",dl);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sdl,strlen(sdl)); 
  labels();
  return 1;
}

int dleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  dl -= 0.002;

if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,DL);
  sprintf(sdl,"%7.3fA",dl);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sdl,strlen(sdl)); 
  labels();

  return 1;
}

int drright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  dl += 0.05;

if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,DL);
  sprintf(sdl,"%7.3fA",dl);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sdl,strlen(sdl)); 
  labels();

  return 1;
}

int dright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  dl += 0.002;

  if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,DL);
  sprintf(sdl,"%7.3fA",dl);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sdl,strlen(sdl)); 
  labels();

  return 1;
}

int r2lleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res2 -= 0.1;

  if(Res2 < 0.01) Res2 = 0.01;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,RES2);
  sprintf(sres2,"%6.3fA",Res2);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sres2,strlen(sres2)); 
  labels();

  return 1;
}

int r2left_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res2 -= 0.001;

  if(Res2 < 0.01) Res2 = 0.01;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,RES2);
  sprintf(sres2,"%6.3fA",Res2);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sres2,strlen(sres2)); 
  labels();

  return 1;
}

int r2rright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res2 += 0.1;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,RES2);
  sprintf(sres2,"%6.3fA",Res2);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sres2,strlen(sres2)); 
  labels();

  return 1;
}

int r2right_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Res2 += 0.001;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,RES2);
  sprintf(sres2,"%6.3fA",Res2);
  XDrawString(theDisplay,DL,theGC,1,fontheight,sres2,strlen(sres2)); 
  labels();

  return 1;
}


int wlleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp;
  char tmp[50]; 

  Wgt -= 0.1;
  if(Wgt < 0.00) Wgt = 0.00;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,WGT);
  sprintf(swgt,"%6.2f",Wgt);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt)); 
  labels();
  return 1;
}

int wleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Wgt -= 0.01;
  if(Wgt < 0.0) Wgt = 0.00;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,WGT);
  sprintf(swgt,"%6.2f",Wgt);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();
  return 1;
}

int wrright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Wgt += 0.1;
  if(Wgt > 1.0) Wgt = 1.0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,WGT);
  sprintf(swgt,"%6.2f",Wgt);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();
  return 1;
}

int wright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Wgt += 0.01;
  if(Wgt > 1.0) Wgt = 1.0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,WGT);
  sprintf(swgt,"%6.2f",Wgt);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();
  return 1;
}

int w2lleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp;
  char tmp[50]; 

  Wgt2 -= 0.1;

  if(Wgt2 < 0.00) Wgt2 = 0.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,WGT2);
  sprintf(swgt2,"%6.2f",Wgt2);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();

  return 1;
}

int w2left_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp;
  char tmp[50]; 

  Wgt2 -= 0.01;

  if(Wgt2 < 0.00) Wgt2 = 0.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,WGT2);
  sprintf(swgt2,"%6.2f",Wgt2);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();

  return 1;
}

int w2rright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp;
  char tmp[50]; 

  Wgt2 += 0.1;

  if(Wgt2 > 1.00) Wgt2 = 1.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,WGT2);
  sprintf(swgt2,"%6.2f",Wgt2);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();

  return 1;
}

int w2right_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp;
  char tmp[50]; 

  Wgt2 += 0.01;

  if(Wgt2 > 1.00) Wgt2 = 1.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,WGT2);
  sprintf(swgt2,"%6.2f",Wgt2);
  XDrawString(theDisplay,WGT,theGC,1,fontheight,swgt,strlen(swgt));
  labels();

  return 1;
}

int vlleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp;
  char tmp[50]; 

  vsini -= 10.0;
  if(vsini < 0.00) vsini = 0.00;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,VSINI);
  sprintf(svsini,"%4.1f km/s",vsini);
  XDrawString(theDisplay,VSINI,theGC,1,fontheight,svsini,strlen(svsini)); 
  labels();
  return 1;
}

int vleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini -= 0.5;
  if(vsini < 0.0) vsini = 0.00;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,VSINI);
  sprintf(svsini,"%4.1f km/s",vsini);
  XDrawString(theDisplay,VSINI,theGC,1,fontheight,svsini,strlen(svsini));
  labels();
  return 1;
}

int vrright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini += 10.0;
  if(vsini > 500.0) vsini = 500.0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,VSINI);
  sprintf(svsini,"%4.1f km/s",vsini);
  XDrawString(theDisplay,VSINI,theGC,1,fontheight,svsini,strlen(svsini));
  labels();
  return 1;
}

int vright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini += 0.5;
  if(vsini > 500.0) vsini = 500.0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,VSINI);
  sprintf(svsini,"%4.1f km/s",vsini);
  XDrawString(theDisplay,VSINI,theGC,1,fontheight,svsini,strlen(svsini));
  labels();
  return 1;
}

int v2lleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini2 -= 10.0;

  if(vsini2 < 0.00) vsini2 = 0.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,VSINI2);
  sprintf(svsini2,"%4.1f km/s",vsini2);
  XDrawString(theDisplay,VSINI2,theGC,1,fontheight,svsini2,strlen(svsini2));
  labels();

  return 1;
}

int v2left_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini2 -= 0.5;

  if(vsini2 < 0.00) vsini2 = 0.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,VSINI2);
  sprintf(svsini2,"%4.1f km/s",vsini2);
  XDrawString(theDisplay,VSINI2,theGC,1,fontheight,svsini2,strlen(svsini2));
  labels();
  return 1;
}

int v2rright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini2 += 10.0;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,VSINI2);
  sprintf(svsini2,"%4.1f km/s",vsini2);
  XDrawString(theDisplay,VSINI2,theGC,1,fontheight,svsini2,strlen(svsini2));
  labels();
  return 1;
}

int v2right_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  vsini2 += 0.5;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,VSINI2);
  sprintf(svsini2,"%4.1f km/s",vsini2);
  XDrawString(theDisplay,VSINI2,theGC,1,fontheight,svsini2,strlen(svsini2));
  labels();
  return 1;
}

int slleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str -= 0.05;
  if(Str < 0.01) Str = 0.01;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,STR);
  sprintf(sstr,"%6.3f",Str);
  XDrawString(theDisplay,STR,theGC,1,fontheight,sstr,strlen(sstr)); 
  labels();
  return 1;
}

int sleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str -= 0.001;
  if(Str < 0.01) Str = 0.01;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,STR);
  sprintf(sstr,"%6.3f",Str);
  XDrawString(theDisplay,STR,theGC,1,fontheight,sstr,strlen(sstr));
  labels();
  return 1;
}

int srright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str += 0.05;
  /*  if(Str > 1.0) Str = 1.0; */
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,STR);
  sprintf(sstr,"%6.3f",Str);
  XDrawString(theDisplay,STR,theGC,1,fontheight,sstr,strlen(sstr));
  labels();
  return 1;
}

int sright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str += 0.001;
  /*  if(Str > 1.0) Str = 1.0; */
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,STR);
  sprintf(sstr,"%6.3f",Str);
  XDrawString(theDisplay,STR,theGC,1,fontheight,sstr,strlen(sstr));
  labels();
  return 1;
}

int s2lleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str2 -= 0.05;
  if(Str2 < 0.00) Str2 = 0.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,STR2);
  sprintf(sstr2,"%6.3f",Str2);
  XDrawString(theDisplay,STR2,theGC,1,fontheight,sstr2,strlen(sstr2));
  labels();

  return 1;
}

int s2left_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str2 -= 0.001;
  if(Str2 < 0.00) Str2 = 0.00;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,STR2);
  sprintf(sstr2,"%6.3f",Str2);
  XDrawString(theDisplay,STR2,theGC,1,fontheight,sstr2,strlen(sstr2));
  labels();
  return 1;
}

int s2rright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str2 += 0.05;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,STR2);
  sprintf(sstr2,"%6.3f",Str2);
  XDrawString(theDisplay,STR2,theGC,1,fontheight,sstr2,strlen(sstr2));
  labels();

  return 1;
}

int s2right_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  Str2 += 0.001;

 if(sbullet == 1) {
   XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
   x1 = 250;
   x2 = width - 25;
   Y1 = height - 75;
   y2 = 75;
   profile2(Res2,Str2,Wgt2);
   XClearWindow(theDisplay,EQW);
   eqw2 = eqwdth2(wave,flux);
   sprintf(seqw2,"W = %6.1f mA",eqw2);
   XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
   qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
   addprofile();
   for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
   }
   XClearWindow(theDisplay,theMain);
   xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
   xplot(iwave,iflux);
  }

  XClearWindow(theDisplay,STR2);
  sprintf(sstr2,"%6.3f",Str2);
  XDrawString(theDisplay,STR2,theGC,1,fontheight,sstr2,strlen(sstr2));
  labels();
  return 1;
}

int sklleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  sk -= 0.1;

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,SKEW);
  sprintf(ssk,"%6.3f",sk);
  XDrawString(theDisplay,SKEW,theGC,1,fontheight,ssk,strlen(ssk));
  labels();  
  return 1;
}

int skleft_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  sk -= 0.01;

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,SKEW);
  sprintf(ssk,"%6.3f",sk);
  XDrawString(theDisplay,SKEW,theGC,1,fontheight,ssk,strlen(ssk));
  labels(); 
  return 1;
}


int skrright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  sk += 0.1;

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,SKEW);
  sprintf(ssk,"%6.3f",sk);
  XDrawString(theDisplay,SKEW,theGC,1,fontheight,ssk,strlen(ssk));
  labels(); 
  return 1;
}


int skright_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  sk += 0.01;

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XClearWindow(theDisplay,SKEW);
  sprintf(ssk,"%6.3f",sk);
  XDrawString(theDisplay,SKEW,theGC,1,fontheight,ssk,strlen(ssk));
  labels(); 
  return 1;
}



double linespread(double x,double xmid,double w,double s,double wt,double sk)
{
  static double c = 2.772588722;
  double arg,ex,lor,y;
  float X;

  arg = (x-xmid)/w;
  X = sk*sign(arg)*sqrt(2.0*arg*arg*c);
  ex = s*exp(-c*arg*arg)*(1.0 + erff(X/1.414213562));
  lor = s/(4.0*arg*arg + 1.0);
  y = (wt*lor + (1.0-wt)*ex);
  return(y);
}

double linespread2(double x,double xmid,double w,double s,double wt)
{
  static double c = 2.772588722;
  double arg,ex,lor,y;

  arg = (x-xmid)/w;
  ex = s*exp(-c*arg*arg);
  lor = s/(4.0*arg*arg + 1.0);
  y = (wt*lor + (1.0-wt)*ex);
  return(y);
}

double profile(double w,double s,double wt)
{
  double xmid;
  double wavp,start,end,xrange;
  int np;

  space = 0.005;
  xrange = 4.0*(xhigh - xlow);
  xmid = (xhigh+xlow)/2.0;
  if(xrange <= 200.0) {
    start = xmid - xrange;
    end = xmid + xrange;
    space = 0.005;
  } else {
    start = xmid - 0.50*xrange/4.0;
    end = xmid + 0.50*xrange/4.0;
    space = 0.05;
  }
  wavp = start;
  np = nd[1];
  while(wavp < end) {
    wave[np] = wavp;
    flux[np] = 1.0 - linespread(wavp,xmid,w,s,wt,sk);
    wavp += space;
    np++;
  }
  nf = 2;
  nd[nf] = np;
}

double profile2(double w,double s,double wt)
{
  double xmid;
  double wavp,start,end,xrange;
  int np,i;

  space = 0.005;
  xrange = 4.0*(xhigh - xlow);
  xmid = dl + (xhigh+xlow)/2.0;
  if(xrange <= 200.0) {
    start = xmid - xrange -dl;
    end = xmid + xrange -dl;
    space = 0.005;
  } else {
    start = xmid - dl - 0.50*xrange/4.0;
    end = xmid  - dl + 0.50*xrange/4.0;
    space = 0.05;
  }
  wavp = start;
  np = nd[2];
  npp = 0;
  while(wavp < end) {
    wave[np] = wavp;
    flux[np] = 1.0 - linespread2(wavp,xmid,w,s,wt);
    wavp += space;
    np++;
    npp++;
  }
  nf = 3;
  nd[nf] = np;
}

void addprofile()
{
  int i;

  nf = 4;
  nd[4] = nd[3] + npp;
  for(i=nd[3];i<nd[4];i++) {
    wave[i] = wave[i-npp];
    flux[i] = flux[i-npp] + flux[i-2*npp] - 1.0;
  }
}



int record_action(caddr_t data)
{
  if(file_flag == 0) return(1);
  if(sbullet == 0) fprintf(rf,"%9.3f  %6.3f\n",mid,eqw);
  if(sbullet == 1) fprintf(rf,"1: %9.3f %6.3f   2: %6.3f %6.3f\n",mid,eqw,dl,
                           eqw2);
  return(1);
}

int file_action(caddr_t data)
{
  printf("\nEnter name of Record Data file > ");
  ggets(Rfile);
  rf = fopen(Rfile,"a");
  file_flag = 1;
  return 1;
}

int up_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  offset -= 1;
  cont = 1.0 + (double)(offset)*(yhigh-ylow)/(double)(y2-Y1);
  printf("continuum = %f\n",cont);
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    eqw2 = eqwdth2(wave,flux);
    XClearWindow(theDisplay,EQW);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  labels();
  return 1;
}

int down_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  offset += 1;
  cont = 1.0 + (double)(offset)*(yhigh-ylow)/(double)(y2-Y1);
  printf("continuum = %f\n",cont);
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    eqw2 = eqwdth2(wave,flux);
    XClearWindow(theDisplay,EQW);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  labels();
  return 1;
}

int restore_action(caddr_t data)
{
  int itemp,i;
  unsigned int width,height,utemp;
  Window wtemp; 
  char tmp[50];

  offset = 0;
  cont = 1.0;
  printf("continuum = %f\n",cont);
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    eqw2 = eqwdth2(wave,flux);
    XClearWindow(theDisplay,EQW);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  labels();
  return 1;
}

float sign(float x)
{
  if(x == 0.0) return (1.0);
  else return(x/fabs(x));
}

void bullet(x,y)
     int x,y;
{
  XDrawArc(theDisplay,theMain,theGC,x-6,y-6,12,12,0,360*64);
  return;
}

void dot(x,y)
int x,y;
{
  XDrawRectangle(theDisplay,theMain,theGC,x-1,y-1,2,2);
  XDrawPoint(theDisplay,theMain,theGC,x,y);
  return;
}

int dot_action(caddr_t data)
{
  if(flagdot == 0) flagdot = 1;
  else flagdot = 0;

  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();

  return 1;
}

int redraw_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;  

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 250;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  mid = (xhigh+xlow)/2.0;
  sprintf(smid,"%9.3f A",mid);
  profile(Res,Str,Wgt);
  eqw = eqwdth(wave,flux);
  XClearWindow(theDisplay,EQW);
  sprintf(seqw,"W = %6.1f mA",eqw);
  XDrawString(theDisplay,EQW,theGC,1,fontheight,seqw,strlen(seqw));
  qvsini(wave+nd[1],flux+nd[1],nd[2]-nd[1],space,vsini,0.75);
  if(sbullet == 1) {
    profile2(Res2,Str2,Wgt2);
    XClearWindow(theDisplay,EQW);
    eqw2 = eqwdth2(wave,flux);
    sprintf(seqw2,"W = %6.1f mA",eqw2);
    XDrawString(theDisplay,EQW2,theGC,1,fontheight,seqw2,strlen(seqw2));
    qvsini(wave+nd[2],flux+nd[2],nd[3]-nd[2],space,vsini2,0.75);
    addprofile();
  }
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    if(i >= nd[1]) iflux[i] += offset;
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  labels();
  return 1;
}

char *ggets(char *s)
{
  size_t n;
  char tmp[300];

  if(fgets(tmp,300,stdin) == NULL) {
    printf("Access error in ggets\n");
    exit(1);
  }
  n = strlen(tmp);
  strncpy(s,tmp,n-1);
  s[n-1] = '\0';
  return(s);
}
