#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <time.h>
#include "xwins.h"
#include "app_glob.c"

char *quit_label = "Quit";
char *load_label = "Load";
char *xscale_label = "Xscale";
char *yscale_label = "Yscale";
char *mousescale_label = "Mouse Scale";
char *right_label = "==>";
char *left_label = "<==";
char *up_label = "^";
char *down_label = "v";
char *zoomin_label = "Zoom In";
char *zoomout_label = "Zoom Out";
char *symbol_label = "Symbol";
char *plus_label = "+";
char *minus_label = "-";
char *reset_label = "Reset Scale";
char *lowpass_label = "Low Pass";
char *autorec_label = "Autorectify";
char *accept_label = "<- Accept";
char *normal_label = "Normalize";
char *fix_label = "Fix";
char *save_label = "Save";
char *lineflux_label = "Line Flux";
char *counts_label = "Counts";
char *eqw_label = "Eq Width";
char *eqw2_label = "EqW2";
char *rect_label = "Rect";
char *cen_label = "Centroid";
char *command_label = "Command";
char *color_label = "Color";
char *scaleflux_label = "Scale Flux";
char *join_label = "Join";
char *setcont_label = "Set Cont";
double *wave,*flux;
unsigned long *indx;
double *fixwave;
double *xar,*yar;
double xrr,yrr;
int *ixar,*iyar;
double xnor,ynor;
int nar;
double *yqs;
double dw;
double pts;
double wRect = 30.0;
int nfix = 0;
int *iwave,*iflux;
int ni;
int flagR = 0;
int flagS = 0;
int flagN = 0;
int flagF = 0;
int flagM = 0;
int flagW = 0;
int flagw = 0;
int flagC = 0;
int flagc = 0;
int flagLF = 0;
int flagSC = 0;
int flagsc = 0;
int flagrect = 0;
int flagcounts = 0;
char head[100][132];
int nh = 0;
int x1=100,Y1=650,x2=1000,y2=50;
double xlow=3800.0,xhigh=4600.0,ylow=0.0,yhigh=1.2;
double xlrec,xhrec;
int ixlrec,ixhrec;
int iylrec,iyhrec;
double x1c,y1c,x2c,y2c;
int ix1c,iy1c,ix2c,iy2c;
double xl=3800.0,yl=0.0;
double nxlow,nxhigh,nylow,nyhigh;
double xpos;
double sum = 0.0;
double sum1 = 0.0;
int xtics,ytics,nxtics,nytics;
int rad;
int nmax;
int POW2[18] = {1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,
                65536,131072};
char infile[300];
char *fname[10];
char recname[300];
char cmd[300],cpcmd[300],cmd1[15],cmd2[300];
int n,nf;
unsigned long nd[20];
unsigned long size = 800000;
int symbol[10] = {0,0,0,0,0,0,0,0,0,0};
XWMHints  xwmh;
XColor White,Green,Red,Grey,Orange,Yellow,exact;
Colormap default_cmap;


void initapp(int,char **,int,int,unsigned,unsigned);
int findfiles();
int quit_action(caddr_t);
int load_action(caddr_t);
int xscale_action(caddr_t);
int yscale_action(caddr_t);
int mousescale_action(caddr_t);
int right_action(caddr_t);
int left_action(caddr_t);
int up_action(caddr_t);
int down_action(caddr_t);
int zoomin_action(caddr_t);
int zoomout_action(caddr_t);
int symbol_action(caddr_t);
int plus_action(caddr_t);
int minus_action(caddr_t);
int plus2_action(caddr_t);
int minus2_action(caddr_t);
int plus3_action(caddr_t);
int minus3_action(caddr_t);
int reset_action(caddr_t);
int lowpass_action(caddr_t);
int autorec_action(caddr_t);
int accept_action(caddr_t);
int normal_action(caddr_t);
int fix_action(caddr_t);
int save_action(caddr_t);
int eqw_action(caddr_t);
int eqw2_action(caddr_t);
int rect_action(caddr_t);
int lineflux_action(caddr_t);
int counts_action(caddr_t);
int cen_action(caddr_t);
int command_action(caddr_t);
int color_action(caddr_t);
int scaleflux_action(caddr_t);
int join_action(caddr_t);
int setcont_action(caddr_t);
void xaxis();
void xplot();
void xplotr();
void autorec();
void sautorec();
void scMaxInterval();
void loadspectrum();
void dot();
void circle();
void filledcircle();
void normalize();
double *dvector();
unsigned long *lvector(long nl,long nh);
void free_dvector();
void smooft();
void Remove();
void fixpix();
void Drawline();
void neon();
int InBetween();
int autorectify();
void eqw1();
void eqw2();
void eqw3();
void lineflux();
void counts();
void rect();
void srect();
void indexx(unsigned long n, double arr[], unsigned long indx[]);
char *ggets(char *s);
Window Pos;
Window Shf;
char title[300];
Cursor crosshair;
Cursor Circle;
Cursor downarrow;
unsigned fontheight;
unsigned long *indx;

main(int arGC, char **argv)
{
  XWIN *QuitButton, *LoadButton, *which_xwin;
  XWIN *XscaleButton, *RightButton, *LeftButton;
  XWIN *ZoomInButton, *ZoomOutButton;
  XWIN *SymbolButton, *PlusButton, *MinusButton;
  XWIN *ResetButton, *LowpassButton;
  XWIN *AutorecButton,*AcceptButton;
  XWIN *NormalButton,*FixButton,*SaveButton;
  XWIN *LineFluxButton,*CountsButton;
  XWIN *YscaleButton,*MousescaleButton;
  XWIN *UpButton,*DownButton,*EqwButton,*Eqw2Button;
  XWIN *CenButton, *Plus2Button, *Minus2Button;
  XWIN *Plus3Button, *Minus3Button, *CommandButton, *ColorButton;
  XWIN *ScaleFluxButton,*JoinButton,*RectButton,*SetContButton;
  unsigned quit_width, quit_height, load_width;
  unsigned xscale_width, right_width, left_width;
  unsigned zoomin_width, zoomout_width;
  unsigned symbol_width,plus_width,minus_width;
  unsigned reset_width,lowpass_width,smooth_width;
  unsigned autorec_width,accept_width,normal_width;
  unsigned fix_width,save_width,yscale_width;
  unsigned lineflux_width,counts_width;
  unsigned mousescale_width,up_width,down_width;
  unsigned eqw_width,eqw2_width,cen_width,command_width,color_width;
  unsigned scaleflux_width,join_width,rect_width,setcont_width;
  char tmp1[300],tmp2[300];
  double dxw,dyw,xcen;
  FILE *in;
  int i,j,k;
  int xs,xe,xs1,xs2,xe1,xe2;
  double xmid;



  wave = (double *) calloc(size,sizeof(double));
  flux = (double *) calloc(size,sizeof(double));
  iwave = (int *) calloc(size,sizeof(int));
  iflux = (int *) calloc(size,sizeof(int));
  xar = (double *) calloc(3000,sizeof(double));
  yar = (double *) calloc(3000,sizeof(double));
  ixar = (int *) calloc(3000,sizeof(int));
  iyar = (int *) calloc(3000,sizeof(int));
  fixwave = (double *) calloc(500,sizeof(double));
  indx = lvector(1,size+1);


  printf("\n\nXMK25  (C) Richard O. Gray 2013 \n\n");

  printf("\nEnter name of spectrum files > ");
  ggets(infile);
  loadspectrum();
  sum = 0.0;  

  xwin_init();

  initapp(arGC,argv,10,10,700,480);
  x1 = 75;
  x2 = 640 - 25;
  Y1 = 480 - 75;
  y2 = 75;

  quit_width = XTextWidth(theFontStruct,quit_label,strlen(quit_label)) + 4;
  quit_height = theFontStruct->max_bounds.ascent +
		theFontStruct->max_bounds.descent + 4;
  fontheight = quit_height - 4;
  QuitButton = MakeXButton(1,1,quit_width,quit_height,1,theFGpix,theBGpix,
	       theMain,quit_label,quit_action,NULL);
  plus_width = XTextWidth(theFontStruct,plus_label,strlen(plus_label)) +4;
  PlusButton = MakeXButton(1,quit_height+4,plus_width,quit_height,1,
               theFGpix,theBGpix,theMain,plus_label,plus_action,NULL);
  MinusButton = MakeXButton(plus_width+4,quit_height+4,plus_width,
               quit_height,1,theFGpix,theBGpix,theMain,minus_label,
               minus_action,NULL);
  reset_width = XTextWidth(theFontStruct,reset_label,strlen(reset_label))+4;
  ResetButton = MakeXButton(2*plus_width+8,quit_height+4,reset_width, 
               quit_height,1,theFGpix,theBGpix,theMain,reset_label,
               reset_action,NULL);
  mousescale_width = XTextWidth(theFontStruct,reset_label,
               strlen(reset_label))+4;
  MousescaleButton = MakeXButton(2*plus_width+reset_width+12,quit_height+4,
               mousescale_width, 
               quit_height,1,theFGpix,theBGpix,theMain,mousescale_label,
               mousescale_action,NULL);
  autorec_width = XTextWidth(theFontStruct,autorec_label,
                  strlen(autorec_label))+4;
  AutorecButton = MakeXButton(2*plus_width+reset_width+mousescale_width+20,
               quit_height+4,autorec_width,
               quit_height,1,theFGpix,theBGpix,theMain,autorec_label,
               autorec_action,NULL); 
  accept_width = XTextWidth(theFontStruct,accept_label,
                  strlen(accept_label))+4;
  AcceptButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               mousescale_width+24,quit_height+4,accept_width,
               quit_height,1,theFGpix,theBGpix,theMain,accept_label,
               accept_action,NULL);
  normal_width = XTextWidth(theFontStruct,normal_label,
                  strlen(normal_label))+4;
  NormalButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+mousescale_width+28,quit_height+4,normal_width,
               quit_height,1,theFGpix,theBGpix,theMain,normal_label,
               normal_action,NULL);
  fix_width = XTextWidth(theFontStruct,fix_label,
                  strlen(fix_label))+4;
  FixButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+normal_width+mousescale_width+32,quit_height+4,
               fix_width,
               quit_height,1,theFGpix,theBGpix,theMain,fix_label,
               fix_action,NULL);
  save_width = XTextWidth(theFontStruct,save_label,
                  strlen(save_label))+4;
  SaveButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+normal_width+fix_width+mousescale_width+36,
               quit_height+4,
               save_width,quit_height,1,theFGpix,theBGpix,theMain,
               save_label,save_action,NULL);
  lineflux_width = XTextWidth(theFontStruct,lineflux_label,
                  strlen(lineflux_label))+4;
  LineFluxButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+normal_width+fix_width+mousescale_width+
               save_width+40,quit_height+4,
               lineflux_width,quit_height,1,theFGpix,theBGpix,theMain,
               lineflux_label,lineflux_action,NULL);
  counts_width = XTextWidth(theFontStruct,counts_label,
                  strlen(counts_label))+4;
  CountsButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+normal_width+fix_width+mousescale_width+
               save_width+lineflux_width+44,quit_height+4,
               counts_width,quit_height,1,theFGpix,theBGpix,theMain,
               counts_label,counts_action,NULL);
  scaleflux_width = XTextWidth(theFontStruct,scaleflux_label,
                  strlen(scaleflux_label))+4;
  ScaleFluxButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+normal_width+fix_width+mousescale_width+
               save_width+lineflux_width+counts_width+48,quit_height+4,
               scaleflux_width,quit_height,1,theFGpix,theBGpix,theMain,
               scaleflux_label,scaleflux_action,NULL);
    color_width = XTextWidth(theFontStruct,color_label,
                            strlen(color_label)) +4;
  ColorButton = MakeXButton(2*plus_width+reset_width+autorec_width+
               accept_width+normal_width+fix_width+mousescale_width+
               save_width+lineflux_width+counts_width+scaleflux_width+52,
               quit_height+4,color_width,quit_height,1,theFGpix,theBGpix,
               theMain,color_label,color_action,NULL);
  load_width = XTextWidth(theFontStruct,load_label,strlen(load_label)) +4;
  LoadButton = MakeXButton(quit_width+4,1,load_width,quit_height,1,
               theFGpix,theBGpix,theMain,load_label,load_action,NULL);
  xscale_width = XTextWidth(theFontStruct,xscale_label,
                            strlen(xscale_label)) +4;
  XscaleButton = MakeXButton(quit_width+load_width+8,1,xscale_width,
               quit_height,1,theFGpix,theBGpix,theMain,xscale_label,
               xscale_action,NULL);
  yscale_width = XTextWidth(theFontStruct,xscale_label,
                            strlen(yscale_label)) +4;
  YscaleButton = MakeXButton(quit_width+load_width+xscale_width+12,
               1,yscale_width,
               quit_height,1,theFGpix,theBGpix,theMain,yscale_label,
               yscale_action,NULL);
  right_width = XTextWidth(theFontStruct,right_label,
                            strlen(right_label)) +4;
  RightButton = MakeXButton(quit_width+load_width+xscale_width+
              yscale_width+16,
              1,right_width,quit_height,1,theFGpix,theBGpix,
              theMain,right_label,right_action,NULL);
  left_width = XTextWidth(theFontStruct,left_label,
                            strlen(left_label)) +4;
  LeftButton = MakeXButton(quit_width+load_width+xscale_width+
              yscale_width+
              right_width+20,1,left_width,quit_height,1,theFGpix,
              theBGpix,theMain,left_label,left_action,NULL);
  up_width = XTextWidth(theFontStruct,up_label,
                            strlen(up_label)) +4;
  UpButton = MakeXButton(quit_width+load_width+xscale_width+
              yscale_width+right_width+left_width+24,1,
              up_width,quit_height,1,theFGpix,
              theBGpix,theMain,up_label,up_action,NULL);
  down_width = XTextWidth(theFontStruct,down_label,
                            strlen(down_label)) +4;
  DownButton = MakeXButton(quit_width+load_width+xscale_width+
              yscale_width+right_width+left_width+up_width+28,1,
              down_width,quit_height,1,theFGpix,
              theBGpix,theMain,down_label,down_action,NULL);
  zoomin_width = XTextWidth(theFontStruct,zoomin_label,
                            strlen(zoomin_label)) +4;
  ZoomInButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+yscale_width+up_width+
              down_width+32,1,zoomin_width,
              quit_height,1,theFGpix,theBGpix,theMain,zoomin_label,
              zoomin_action,NULL);
  zoomout_width = XTextWidth(theFontStruct,zoomout_label,
                            strlen(zoomout_label)) +4;
  ZoomOutButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+yscale_width+
              up_width+down_width+36,1,zoomout_width,
              quit_height,1,theFGpix,theBGpix,theMain,zoomout_label,
              zoomout_action,NULL);
  symbol_width = XTextWidth(theFontStruct,symbol_label,
                            strlen(symbol_label)) +4;
  SymbolButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              yscale_width+up_width+down_width+40,1,
              symbol_width,quit_height,1,theFGpix,theBGpix,theMain,
              symbol_label,symbol_action,NULL);
  lowpass_width = XTextWidth(theFontStruct,lowpass_label,
                            strlen(lowpass_label)) +4;
  LowpassButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+44,1,lowpass_width,
              quit_height,1,theFGpix,theBGpix,theMain,lowpass_label,
              lowpass_action,NULL);
  eqw_width = XTextWidth(theFontStruct,eqw_label,
                            strlen(eqw_label)) +4;
  EqwButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+
              lowpass_width+48,1,eqw_width,
              quit_height,1,theFGpix,theBGpix,theMain,eqw_label,
              eqw_action,NULL);
  eqw2_width = XTextWidth(theFontStruct,eqw2_label,
                            strlen(eqw2_label)) +4;
  Eqw2Button = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+
              lowpass_width+eqw_width+52,1,eqw2_width,
              quit_height,1,theFGpix,theBGpix,theMain,eqw2_label,
              eqw2_action,NULL);
  rect_width = XTextWidth(theFontStruct,rect_label,
                            strlen(rect_label)) +4;
  RectButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+
              lowpass_width+eqw_width+eqw2_width+56,1,rect_width,
              quit_height,1,theFGpix,theBGpix,theMain,rect_label,
              rect_action,NULL);
  cen_width = XTextWidth(theFontStruct,cen_label,
                            strlen(cen_label)) +4;
  CenButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+
              lowpass_width+eqw_width+eqw2_width+rect_width+60,1,cen_width,
              quit_height,1,theFGpix,theBGpix,theMain,cen_label,
              cen_action,NULL);
  join_width = XTextWidth(theFontStruct,join_label,
                            strlen(join_label)) +4;
  JoinButton = MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+
              lowpass_width+eqw_width+cen_width+eqw2_width+rect_width+64,
              1,join_width,
              quit_height,1,theFGpix,theBGpix,theMain,join_label,
              join_action,NULL);
  setcont_width = XTextWidth(theFontStruct,setcont_label,
                            strlen(setcont_label)) +4;  
  SetContButton =  MakeXButton(quit_width+load_width+xscale_width+
              right_width+left_width+zoomin_width+zoomout_width+
              symbol_width+yscale_width+up_width+down_width+
              lowpass_width+eqw_width+cen_width+eqw2_width+rect_width+
              join_width+68,1,setcont_width,
              quit_height,1,theFGpix,theBGpix,theMain,setcont_label,
              setcont_action,NULL);
  Plus2Button = MakeXButton(1,2*quit_height+8,plus_width,quit_height,1,
               theFGpix,theBGpix,theMain,plus_label,plus2_action,NULL);
  Minus2Button = MakeXButton(plus_width+4,2*quit_height+8,plus_width,
               quit_height,1,theFGpix,theBGpix,theMain,minus_label,
               minus2_action,NULL);
  Plus3Button = MakeXButton(1,3*quit_height+12,plus_width,quit_height,1,
               theFGpix,theBGpix,theMain,plus_label,plus3_action,NULL);
  Minus3Button = MakeXButton(plus_width+4,3*quit_height+12,plus_width,
               quit_height,1,theFGpix,theBGpix,theMain,minus_label,
               minus3_action,NULL);
  command_width = XTextWidth(theFontStruct,command_label,
                            strlen(command_label)) +4;
  CommandButton = MakeXButton(2*plus_width+8,2*quit_height+8,
               command_width,quit_height,1,theFGpix,theBGpix,theMain,
               command_label,command_action,NULL);


  default_cmap=DefaultColormap(theDisplay,DefaultScreen(theDisplay));
  XAllocNamedColor(theDisplay,default_cmap,"red",&exact,&Red);
  XAllocNamedColor(theDisplay,default_cmap,"green",&exact,&Green);
  XAllocNamedColor(theDisplay,default_cmap,"grey40",&exact,&Grey);
  XAllocNamedColor(theDisplay,default_cmap,"white",&exact,&White); 
  XAllocNamedColor(theDisplay,default_cmap,"orange",&exact,&Orange);
  XAllocNamedColor(theDisplay,default_cmap,"yellow",&exact,&Yellow); 


  XSelectInput(theDisplay,theMain,ExposureMask|PointerMotionMask|
     ButtonPressMask|OwnerGrabButtonMask|ButtonReleaseMask|
     ButtonMotionMask);

  Pos = XCreateSimpleWindow(theDisplay,theMain,x1,Y1+35,150,
         2*fontheight+8,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,Pos);
  Shf = XCreateSimpleWindow(theDisplay,theMain,2*plus_width+command_width+15,
        2*quit_height+8,60,fontheight+8,0,theFGpix,theBGpix);
  XMapWindow(theDisplay,Shf);
  

  crosshair = XCreateFontCursor(theDisplay,XC_tcross);
  Circle = XCreateFontCursor(theDisplay,XC_tcross);
  downarrow = XCreateFontCursor(theDisplay,XC_sb_down_arrow);
  XDefineCursor(theDisplay,theMain,crosshair);

  dw = (wave[3] - wave[1])/8.0;

  while(!AppDone) {
    XNextEvent(theDisplay,&theEvent);
    if(theEvent.xany.window == theMain) {
      switch(theEvent.type) {
        case Expose:
          if(theEvent.xexpose.count == 0) {
	    int itemp;
	    unsigned int width,height,utemp;
	    Window wtemp;
	    if(XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
	       &width,&height,&utemp,&utemp) == 0) break;
	    x1 = 75;
	    x2 = width - 25;
	    Y1 = height - 75;
	    y2 = 75;
            XMoveWindow(theDisplay,Pos,x1,Y1+35);
	    for(i=0;i<nd[nf];i++) {
	     iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
	     iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
	    }
            if(flagR == 1) {
              for(i=0;i<nar;i++) {
                ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
                iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
              }
            }
	    XClearWindow(theDisplay,theMain);
	    xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
	    xplot(iwave,iflux);
            if(flagR == 1) xplotr();
	    if(flagrect == 1) rect();
          }
          break;

        case ButtonPress:
             switch(theEvent.xbutton.button) {
                case Button1: {
                     Window rw,cw;
                     int xr,yr,xw,yw,kbstat;
                     XQueryPointer(theDisplay,theEvent.xmotion.window,
                       &rw,&cw,&xr,&yr,&xw,&yw,&kbstat);
                     if(flagR == 1 && flagM == 0) {
                       xar[nar] = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       yar[nar] = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       nar++;
                       piksr2(nar,xar,yar);
                       for(i=0;i<nar;i++) {
                          ixar[i] = x1+(x2-x1)*(xar[i]-xlow)/(xhigh-xlow);
                          iyar[i] = Y1+(y2-Y1)*(yar[i]-ylow)/(yhigh-ylow);
                       }
                       XClearWindow(theDisplay,theMain);
                       xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,
                             x1,x2,Y1,y2);
                       xplot(iwave,iflux);
                       xplotr();
                       if(flagrect == 1) rect();
                     }
                     if(flagN == 1 && flagM == 0) {
                       ynor = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       xnor = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                     (double)(x2-x1);
                       normalize();
                       XUndefineCursor(theDisplay,theMain);
                       XDefineCursor(theDisplay,theMain,crosshair);
                       XClearWindow(theDisplay,theMain);
                       xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,
                             x1,x2,Y1,y2);
                       xplot(iwave,iflux);
                       flagN = 0;
                       if(flagrect == 1) rect();
                     }
                     if(flagF == 1 && flagM == 0) {
                       xpos = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       fixpix();
                       XClearWindow(theDisplay,theMain);
                       xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,
                             x1,x2,Y1,y2);
                       xplot(iwave,iflux);
                       if(flagrect == 1) rect();
                     }
                     if(flagC == 1 && flagM == 0) {
                       xcen = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       neon(wave,flux,xcen);
                     }
                     if(flagW == 2 && flagM == 0) {
                       xe = xw;
                       eqw1(xs,xe);
                       flagW = 1;
                     } else if(flagW == 1 && flagM == 0) {
                       xs = xw;
                       flagW = 2;
                     }
		     if(flagW == 3 && flagM == 0) {
		       if(flagw == 0) {
                         xs1 = xw;
			 flagw = 1;
			 printf("Now define continuum point 2\n");
		       } else if(flagw == 1) {
			 xs2 = xw;
			 flagw = 2;
			 printf("Now define continuum point 3\n");
		       } else if(flagw == 2) {
			 xe1 = xw;
			 flagw = 3;
			 printf("Now define continuum point 4\n");
		       } else if(flagw == 3) {
			 xe2 = xw;
			 flagw = 4;
		       }
		       if(flagw == 4) {
                         eqw2(xs1,xs2,xe1,xe2);
			 flagw == 0;
		       }
		     }
		     if(flagLF == 2 && flagM == 0) {
		       xe = xw;
		       lineflux(xs,xe);
		       flagLF = 1;
		     } else if(flagLF == 1 && flagM == 0) {
		       xs = xw;
		       flagLF = 2;
		     }
		     if(flagSC == 2 && flagLF == 0) {
		       ix2c = xw;
		       iy2c = yw;
                       x2c = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       y2c = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       XSetForeground(theDisplay,theGC,Red.pixel);
		       dot(ix2c,iy2c);
                       XSetForeground(theDisplay,theGC,Green.pixel);
                       Drawline(ix1c,iy1c,ix2c,iy2c);
                       XSetForeground(theDisplay,theGC,White.pixel);
		       flagSC = 3;
		     }
		     if(flagSC == 1 && flagLF == 0) {
		       ix1c = xw;
		       iy1c = yw;
                       x1c = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       y1c = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       XSetForeground(theDisplay,theGC,Red.pixel);
		       dot(ix1c,iy1c);
                       XSetForeground(theDisplay,theGC,White.pixel);
		       flagSC = 2;
		     } 
		     if(flagcounts == 2 && flagM == 0) {
		       xe = xw;
		       counts(xs,xe);
		       flagcounts = 1;
		     } else if(flagcounts == 1 && flagM == 0) {
		       xs = xw;
		       flagcounts = 2;
		     } 
                     if(flagM == 2) {
                       xhigh = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       yhigh = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       xlow = xl;
                       ylow = yl;
                       for(i=0;i<nd[nf];i++) {
	                iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
	                iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
	               }
                       if(flagR == 1) {
                         for(i=0;i<nar;i++) {
                           ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
                           iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
                         }
                       }
	               XClearWindow(theDisplay,theMain);
	               xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
	               xplot(iwave,iflux);
                       if(flagR == 1) xplotr();
                       if(flagrect == 1) rect();
                       flagM = 0;
                     }
                     if(flagM == 1) {
                       xl = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       yl = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       flagM = 2;
                     }
                     break;
                  }

                case Button3: {
                     Window rw,cw;
                     int xr,yr,xw,yw,kbstat;
                     XQueryPointer(theDisplay,theEvent.xmotion.window,
                       &rw,&cw,&xr,&yr,&xw,&yw,&kbstat);
                     if(flagR == 1) {
                       xrr = xlow + (double)(xw-x1)*(xhigh-xlow)/
                                  (double)(x2-x1);
                       yrr = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
                       Remove(xrr,xlow,xhigh);
                       for(i=0;i<nar;i++) {
                          ixar[i] = x1+(x2-x1)*(xar[i]-xlow)/(xhigh-xlow);
                          iyar[i] = Y1+(y2-Y1)*(yar[i]-ylow)/(yhigh-ylow);
                       }
                       printf("nar = %d xrr = %f\n",nar,xrr);
                       XClearWindow(theDisplay,theMain);
                       xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,
                             x1,x2,Y1,y2);
                       xplot(iwave,iflux);
                       xplotr();
                     }
                     if(flagrect == 1) rect();
                     break;
                  }
              }
                     
                     

        case MotionNotify: {
            Window rw,cw;
            int xr,yr,xw,yw,kbstat;
            XQueryPointer(theDisplay,theEvent.xmotion.window,
              &rw,&cw,&xr,&yr,&xw,&yw,&kbstat);
            dxw = xlow + (double)(xw-x1)*(xhigh-xlow)/(double)(x2-x1);
            dyw = ylow + (yw-Y1)*(yhigh-ylow)/(y2-Y1);
            sprintf(tmp1,"x = %12.7g",dxw);
            sprintf(tmp2,"y = %12.6g",dyw);
            XClearWindow(theDisplay,Pos);
            if(xw >= x1 && xw <= x2 && yw >= y2 && yw <= Y1) {
              XDrawString(theDisplay,Pos,theGC,1,fontheight,
                tmp1,strlen(tmp1));
              XDrawString(theDisplay,Pos,theGC,1,2*fontheight+2,      
                tmp2,strlen(tmp2));
            }
            break;
          }

      }
    }
    if(XFindContext(theDisplay,theEvent.xany.window,xwin_context,
       (caddr_t *) &which_xwin) == 0) {
       if(*(which_xwin->event_handler) != NULL)
	 (*(which_xwin->event_handler))(which_xwin);
    }
  }
  XCloseDisplay(theDisplay);
  exit(0);
}

int quit_action(caddr_t data)
{
  AppDone = 1;
  return 1;
}

int load_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
 
  for(i=0;i<10;i++) symbol[i] = 0;
  flagR = flagS = flagW = flagC = flagM = flagN = flagF = 0;
  XUndefineCursor(theDisplay,theMain);   
  XDefineCursor(theDisplay,theMain,crosshair);


  printf("\nEnter new spectrum files > ");
  ggets(infile);
  while(findfiles(infile) != 0) {
   printf("\nEnter name of spectrum files > ");
   ggets(infile);
  }

  loadspectrum();
  sum = 0.0;
  sum1 = 0.0;
  pts = 0.0;
  nfix = 0;
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int xscale_action(caddr_t data)
{
  int i;  
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  char *temp,buffer[300];

  printf("\nEnter new xlow, xhigh, ntics > ");
  ggets(buffer);
  temp = strtok(buffer,",");
  xlow = atof(temp);
  temp = strtok(NULL,",");
  xhigh = atof(temp);
  temp = strtok(NULL,",");
  xtics = atoi(temp);
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr(); 
  if(flagrect == 1) rect(); 
  return 1;
}

int yscale_action(caddr_t data)
{
  int i;  
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  char *temp,buffer[300];

  printf("\nEnter new ylow, yhigh, ntics > ");
  ggets(buffer);
  temp = strtok(buffer,",");
  ylow = atof(temp);
  temp = strtok(NULL,",");
  yhigh = atof(temp);
  temp = strtok(NULL,",");
  ytics = atoi(temp);
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr(); 
  if(flagrect == 1) rect(); 
  return 1;
}

int mousescale_action(caddr_t data)
{
  flagM = 1;
  printf("\nTo scale the graph using the mouse, position the cursor at the\n");
  printf("lower left hand corner of the box that you wish to be zoomed,\n");
  printf("click the left-hand button, then position the cursor at the\n");
  printf("upper right hand corner of the box, and click once again on the\n");
  printf("left-hand button.\n");
  return 1;
}

int reset_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  xlow = xhigh = wave[0];
  ylow = yhigh = flux[0];
  for(i=0;i<nd[nf];i++) {
    if(xlow > wave[i]) xlow = wave[i];
    if(xhigh < wave[i]) xhigh = wave[i];
    if(ylow > flux[i]) ylow = flux[i];
    if(yhigh < flux[i]) yhigh = flux[i];
  }
  scMaxInterval(xlow,xhigh,10,&nxlow,&nxhigh,&nxtics);
  scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
  xlow = nxlow;
  xhigh = nxhigh;
  xtics = nxtics;
  ylow = nylow;
  yhigh = nyhigh;
  ytics = nytics;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int right_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;
  xw = xhigh - xlow;
  xmid = (xhigh + xlow)/2.0;
  xlow = xlow + 0.10*xw;
  xhigh = xhigh + 0.10*xw;
  

  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int left_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;   
  double xmid,xw;   
  
  xw = xhigh - xlow;
  xmid = (xhigh + xlow)/2.0;
  xlow = xlow - 0.10*xw;
  xhigh = xhigh - 0.10*xw;
   
  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75; 
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int up_action(caddr_t data)
{

  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;   
  double ymid,yw;   
  
  yw = yhigh - ylow;
  ymid = (yhigh + ylow)/2.0;
  ylow = ylow + 0.10*yw;
  yhigh = yhigh + 0.10*yw;
   
  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75; 
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int down_action(caddr_t data)
{

  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;   
  double ymid,yw;   
  
  yw = yhigh - ylow;
  ymid = (yhigh + ylow)/2.0;
  ylow = ylow - 0.10*yw;
  yhigh = yhigh - 0.10*yw;
   
  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75; 
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int zoomin_action(caddr_t data)
{
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;

  xw = (xhigh - xlow)/1.25;
  xmid = (xhigh + xlow)/2.0;
  xlow = xmid - xw/2.0;
  xhigh = xmid + xw/2.0;


  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int zoomout_action(caddr_t data)
{ 
  int i;
  int itemp;
  unsigned int width,height,utemp;
  Window wtemp;
  double xmid,xw;
  
  xw = 1.25*(xhigh - xlow);
  xmid = (xhigh + xlow)/2.0;
  xlow = xmid - xw/2.0;
  xhigh = xmid + xw/2.0;

  
  XGetGeometry(theDisplay,theMain,&wtemp,&itemp,&itemp,
           &width,&height,&utemp,&utemp);
  x1 = 75;
  x2 = width - 25;
  Y1 = height - 75;
  y2 = 75;
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
  if(flagR == 1) {
    for(i=0;i<nar;i++) {
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
      iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1; 
}

int symbol_action(caddr_t data)
{
  int i;
  char ch[4];
  
  printf("\n\nSymbols:\n");
  printf("\n0: no symbols");
  printf("\n1: dots with connecting lines");
  printf("\n2: open circles with no connecting lines");
  printf("\n3: filled circles with no connecting lines");

  for(i=0;i<nf;i++) {
   printf("\n\nEnter symbol for file %d > ",i+1);
   ggets(ch);
   symbol[i] = atoi(ch);
  }

  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}


int plus_action(caddr_t data)
{
  int i;

  for(i=0;i<nd[1];i++) wave[i] += dw;
  sum1 += dw;  

  for(i=0;i<nd[1];i++) 
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  if(flagR == 1) {
    for(i=0;i<nar;i++) 
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1; 
}

int minus_action(caddr_t data)
{
  int i;
  
  for(i=0;i<nd[1];i++) wave[i] -= dw;
  sum1 -= dw;
  
  for(i=0;i<nd[1];i++)
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  if(flagR == 1) {
    for(i=0;i<nar;i++) 
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}

int plus2_action(caddr_t data)
{
  int i;
  char tmpx[40];

  if(nf < 2) return 1;
  for(i=nd[1];i<nd[2];i++) wave[i] += dw/4.0;
  sum += dw/4.0;  

  for(i=nd[1];i<nd[2];i++) 
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  if(flagR == 1) {
    for(i=0;i<nar;i++) 
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  
  sprintf(tmpx,"%6.3f",sum);
  XClearWindow(theDisplay,Shf);
  XDrawString(theDisplay,Shf,theGC,1,fontheight,tmpx,strlen(tmpx)); 

  return 1; 
}

int minus2_action(caddr_t data)
{
  int i;
  char tmpx[40];
  
  if(nf < 2) return 1;
  for(i=nd[1];i<nd[2];i++) wave[i] -= dw/4.0;
  sum -= dw/4.0;  

  for(i=nd[1];i<nd[2];i++)
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  if(flagR == 1) {
    for(i=0;i<nar;i++) 
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();

  sprintf(tmpx,"%6.3f",sum);
  XClearWindow(theDisplay,Shf);
  XDrawString(theDisplay,Shf,theGC,1,fontheight,tmpx,strlen(tmpx)); 

  return 1;
}

int plus3_action(caddr_t data)
{
  int i;

  if(nf < 3) return 1;
  for(i=nd[2];i<nd[3];i++) wave[i] += dw;  

  for(i=nd[2];i<nd[3];i++) 
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  if(flagR == 1) {
    for(i=0;i<nar;i++) 
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1; 
}

int command_action(caddr_t data)
{
  char *tmp;

  printf("\nEnter system command > ");
  ggets(cmd);
  strcpy(cmd2,cmd);
  tmp = strtok(cmd2," ");
  if(strcmp(cmd2,"cd") == 0) {
    tmp = strtok(NULL," ");
    ni = chdir(tmp);
    ni = system("pwd");
    printf("is the current working directory\n");
  } else {
    ni = system(cmd);
  }
  printf("\n");
  return 1;
}

int color_action(caddr_t data)
{
  if(flagc == 0) flagc = 1;
  else flagc = 0;

  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();

  return 1;
}

int minus3_action(caddr_t data)
{
  int i;
  
  if(nf < 3) return 1;
  for(i=nd[2];i<nd[3];i++) wave[i] -= dw;
  
  for(i=nd[2];i<nd[3];i++)
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
  if(flagR == 1) {
    for(i=0;i<nar;i++) 
      ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);          
  }
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  if(flagR == 1) xplotr();
  if(flagrect == 1) rect();
  return 1;
}


int lowpass_action(caddr_t data)
{
  int i,m,nn,j;
  char tmp[20];

  if(flagR == 0) {
    printf("\nLow Pass Filter Smoothing Routine.");  
    printf("\nNote:  Smoothing is cumulative; if you wish to change");
    printf("\nthe degree of smoothing, reload the spectrum\n");
  }

  printf("\nEnter number of points for smoothing > ");
  ggets(tmp);
  pts = atof(tmp);

  nmax = nd[1];
  for(i=2;i<nf;i++) {
    if(nmax < nd[i]-nd[i-1]) nmax = nd[i]-nd[i-1];
  }
  if(nmax > 131072) {
    printf("\nToo many points to smooth file\n");
    return(0);
  }
  for(i=0;i<18;i++) {
    if(nmax <= POW2[i]) {
      nn = i+1;
      break;
    }
  }
  if((yqs = dvector(1,POW2[nn])) == NULL) {
    printf("Cannot allocate space for smoothing spectrum\n");
    return(0);
  }
  if(flagR == 0) {
    for(i=0;i<nf;i++) {
      m = 1;
      for(j=nd[i];j<nd[i+1]-1;j++) {
        yqs[m] = flux[j];
        m++;
      }
      smooft(yqs,m-1,pts);
      m = 1;
      for(j=nd[i];j<nd[i+1]-1;j++) {
        flux[j] = yqs[m];
        m++;
      }
    }
    for(i=0;i<nd[nf];i++) 
      iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    XClearWindow(theDisplay,theMain);
    xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
    xplot(iwave,iflux);
    free_dvector(yqs,1,POW2[nn]);
    return 1;
  } else if(flagR == 1) {
    flagS = 1;
    m = 1;
    for(i=0;i<nd[1];i++) {
      yqs[m] = flux[i];
      m++;
    }
    smooft(yqs,m-1,pts);
    m = 1;
    nf = 2;
    nd[2] = 2*nd[1];
    for(j=nd[1];j<nd[2];j++) {
      flux[j] = yqs[m];
      wave[j] = wave[j-nd[1]];
      m++;
    }
    for(i=0;i<nd[nf];i++) {
      iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
      iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    }
    sautorec(wave,flux,nd[1]-1,&nar);
    printf("nar = %d\n",nar);
    for(i=0;i<nar;i++) {
       ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
       iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
    }
    XClearWindow(theDisplay,theMain);
    xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
    xplot(iwave,iflux);
    xplotr();
    if(flagrect == 1) rect();
    free_dvector(yqs,1,POW2[nn]);
    return 1;
  }
    
 }  

int eqw_action(caddr_t data)
{
   flagR = flagS = flagN = flagF = flagM = flagC = flagLF = 0;
   
   if(flagW == 0) flagW = 1;
   else flagW = 0;

   if(flagW == 0) {
     printf("\nEquivalent Width facility off\n");
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,crosshair);
   }
   if(flagW == 1) {
     printf("\nEquivalent Width facility on\n");
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,downarrow);
   }
   return 1;
}

int eqw2_action(caddr_t data)
{
  flagR = flagS = flagN = flagF = flagM = flagC = flagLF = flagw = 0;
   
   if(flagW == 0) flagW = 3;
   else flagW = 0;

   if(flagW == 0) {
     printf("\nEquivalent Width facility #2 off\n");
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,crosshair);
   }
   if(flagW == 3) {
     printf("\nEquivalent Width facility #2 on\n");
     printf("Define continuum points as follows:\n");
     printf("---1-----2 line 3-----4---\n");
     printf("with four different left-button clicks\n");
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,downarrow);
   }
  return 1;
}

int lineflux_action(caddr_t data)
{
  if(flagsc == 0) {
    printf("\nSet Continuum with Set Cont button first!\n");
    return 1;
  }

  flagR = flagS = flagN = flagF = flagM = flagC = flagW = 0;

  if(flagLF == 0) flagLF = 1;
  else flagLF = 0;

  if(flagLF == 0) {
    printf("\nLine Flux facility off\n");
    XUndefineCursor(theDisplay,theMain);
    XDefineCursor(theDisplay,theMain,crosshair);
  }
  if(flagLF == 1) {
    printf("\nLine Flux facility on\n");
    XUndefineCursor(theDisplay,theMain);
    XDefineCursor(theDisplay,theMain,downarrow);
  }
  return 1;
}

int setcont_action(caddr_t data)
{
  flagR = flagS = flagN = flagF = flagM = flagC = flagW = flagLF = 0;
  flagSC = 1;
  flagsc = 1;
  return 1;
}

int counts_action(caddr_t data)
{
  flagR = flagS = flagN = flagF = flagM = flagC = flagW = 0;

  if(flagcounts == 0) flagcounts = 1;
  else flagcounts = 0;

  if(flagcounts == 0) {
    printf("\nCounts facility off\n");
    XUndefineCursor(theDisplay,theMain);
    XDefineCursor(theDisplay,theMain,crosshair);
  }
  if(flagcounts == 1) {
    printf("\nCounts facility on\n");
    XUndefineCursor(theDisplay,theMain);
    XDefineCursor(theDisplay,theMain,downarrow);
  }
  return 1;
}

int rect_action(caddr_t data)
{
  double xmid;
  char WREC[20];

  if(flagrect == 2) flagrect = 0;
  if(flagrect == 1) flagrect = 2;
  if(flagrect == 0) flagrect = 1;

  if(flagrect == 1) {
    printf("\nEnter rectangle width in Angstroms (%5.1f) > ",wRect);
    ggets(WREC);
    if(strcmp(WREC,"") != 0) wRect = atof(WREC);
    xmid = (xlow + xhigh)/2.0;
    xlrec = xmid - wRect/2.0;
    xhrec = xmid + wRect/2.0;
    ixlrec = x1 + (x2 - x1)*(xlrec-xlow)/(xhigh-xlow);
    ixhrec = x1 + (x2 - x1)*(xhrec-xlow)/(xhigh-xlow);
    iylrec = Y1 + (y2 - Y1)*(0.0-ylow)/(yhigh-ylow);
    iyhrec = Y1 + (y2 - Y1)*(1.0-ylow)/(yhigh-ylow);
    XSetForeground(theDisplay,theGC,Red.pixel);    
    Drawline(ixlrec,iylrec,ixlrec,iyhrec);
    Drawline(ixhrec,iylrec,ixhrec,iyhrec);
    XSetForeground(theDisplay,theGC,White.pixel);
  }

  if(flagrect == 2) {
    srect();
    flagrect = 0;
  } 

  return 1;
}

int cen_action(caddr_t data)
{
   char tmp[10];

   flagR = flagS = flagN = flagF = flagM = flagW = flagLF = 0;
   rad = 5;

   if(flagC == 0) flagC = 1;
   else flagC = 0;

   if(flagC == 0) {
    printf("\nCentroid facility off\n");
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,crosshair);
   }
   if(flagC == 1) {
     printf("\nCentroid facility on\n");
     printf("This facility measures the centroids of emission lines\n");
     printf("\nEnter radius in pixels for determining the centroid > ");
     ggets(tmp);
     printf("\n");
     rad = atoi(tmp);
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,downarrow);
   }
   return 1; 
}

int join_action(caddr_t data)
{
  char output[300];
  FILE *out;
  unsigned long i;

  printf("\nEnter name of output joined spectrum > ");
  ggets(output);

  out = fopen(output,"w");

  indexx(nd[nf], wave-1, indx);
  for(i=1;i<nd[nf];i++) 
    fprintf(out,"%f %e\n",wave[indx[i]-1],flux[indx[i]-1]);
  fclose(out);
  printf("\nJoined spectrum output in %s\n",output);
  return 1;
}

void xplot(iwave,iflux)
int *iwave,*iflux;
{
  int i,j,k;


  for(j=0;j<nf;j++) {
    if(flagc == 1 && j%5 == 0) XSetForeground(theDisplay,theGC,White.pixel);
    if(flagc == 1 && j%5 == 1) XSetForeground(theDisplay,theGC,Red.pixel);
    if(flagc == 1 && j%5 == 2) XSetForeground(theDisplay,theGC,Orange.pixel);
    if(flagc == 1 && j%5 == 3) XSetForeground(theDisplay,theGC,Yellow.pixel);
    if(flagc == 1 && j%5 == 4) XSetForeground(theDisplay,theGC,Green.pixel);
    if(j == 0 && flagR == 1 && flagS == 1)
         XSetForeground(theDisplay,theGC,Grey.pixel);
    if(j == 1 && flagR == 1)
         XSetForeground(theDisplay,theGC,Green.pixel);
    for(i=nd[j];i<nd[j+1]-1;i++) {
      if(symbol[j] <= 1) Drawline(iwave[i],iflux[i],iwave[i+1],iflux[i+1]);
    }
    for(i=nd[j];i<=nd[j+1]-1;i++) {
      if(iwave[i] >= x1 && iwave[i] <= x2 && iflux[i] >= y2 && iflux[i] <= Y1)
      { 
        if(symbol[j] == 1) dot(iwave[i],iflux[i]);
        if(symbol[j] == 2) circle(iwave[i],iflux[i]);
        if(symbol[j] == 3) filledcircle(iwave[i],iflux[i]);
      } 
    }
    if(flagR == 1)
         XSetForeground(theDisplay,theGC,White.pixel);
  }
  XSetForeground(theDisplay,theGC,White.pixel);
}

void Drawline(iw1,ifx1,iw2,ifx2)
int iw1,iw2,ifx1,ifx2;
{
  int xmid,ymid,fx1,fx2,fy1,fy2;
  int xrange,yrange;
  int n,yL,yH,xL,xH;

  xrange = abs(x2-x1)/2;
  yrange = abs(Y1-y2)/2;
  xmid = (x1 + x2)/2.0;
  ymid = (Y1 + y2)/2.0;

  fx1 = abs(iw1-xmid);
  fx2 = abs(iw2-xmid);
  fy1 = abs(ifx1-ymid);
  fy2 = abs(ifx2-ymid);

  if(iw1 == x1 && iw2 == x2 && ((Y1 == y2 == 0) || (ifx1 == Y1 && ifx2 == y2)))
  {
    XDrawLine(theDisplay,theMain,theGC,iw1,ifx1,iw2,ifx2);
    return;
  }
  if(fy1 <= yrange && fy2 <= yrange) {
    if(fx1 <= xrange && fx2 <= xrange) {
      XDrawLine(theDisplay,theMain,theGC,iw1,ifx1,iw2,ifx2);
      return;
    }
    if(fx1 > xrange && fx2 > xrange) return;
    if((n = InBetween(iw1,x1,iw2)) == 1 && fx1 > xrange && iw2 != iw1) {
      yL = ifx1 + (ifx2-ifx1)*(x1-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x1,yL,iw2,ifx2);
      return;
    }
    if((n = InBetween(iw1,x1,iw2)) == 1 && fx1 <= xrange && iw2 != iw1) {
      yL = ifx1 + (ifx2-ifx1)*(x1-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x1,yL,iw1,ifx1);
      return;
    }
    if((n = InBetween(iw1,x2,iw2)) == 1 && fx2 > xrange && iw2 != iw1) {
      yH = ifx1 + (ifx2-ifx1)*(x2-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x2,yH,iw1,ifx1);
      return;
    }
    if((n = InBetween(iw1,x2,iw2)) == 1 && fx2 <= xrange && iw2 != iw1) {
      yH = ifx1 + (ifx2-ifx1)*(x2-iw1)/(iw2-iw1);
      XDrawLine(theDisplay,theMain,theGC,x2,yH,iw2,ifx2);
      return;
    }
  }
  if(fy1 > yrange && fy2 > yrange) return;
  if((n = InBetween(ifx2,Y1,ifx1)) == 1 && fy1 > yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xL = iw1 + (iw2-iw1)*(Y1-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xL,Y1,iw2,ifx2);
      return;
  }
  if((n = InBetween(ifx2,Y1,ifx1)) == 1 && fy1 <= yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xL = iw1 + (iw2-iw1)*(Y1-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xL,Y1,iw1,ifx1);
      return;
  }
  if((n = InBetween(ifx2,y2,ifx1)) == 1 && fy1 <= yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xH = iw1 + (iw2-iw1)*(y2-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xH,y2,iw1,ifx1);
      return;
  }
  if((n = InBetween(ifx2,y2,ifx1)) == 1 && fy1 > yrange && fx1 <= xrange &&
    fx2 <= xrange && ifx1 != ifx2) {
      xH = iw1 + (iw2-iw1)*(y2-ifx1)/(ifx2-ifx1);
      XDrawLine(theDisplay,theMain,theGC,xH,y2,iw2,ifx2);
      return;
  }
  return;
}

int InBetween(x0,x1,x2)
int x0,x1,x2;
{
  if(x1 > x0 && x1 > x2) return(0);
  if(x1 < x0 && x1 < x2) return(0);
  if(x0 == x2) return(0);
  return(1);
}


void xplotr()
{
  int i,ymid;

  for(i=0;i<nar-1;i++) Drawline(ixar[i],iyar[i],ixar[i+1],iyar[i+1]);
  XSetForeground(theDisplay,theGC,Red.pixel); 
  for(i=0;i<nar;i++) { 
   if(ixar[i] >= x1 && ixar[i] <= x2 && iyar[i] >= y2 && iyar[i] <= Y1) {  
      dot(ixar[i],iyar[i]);
   }
  }
  XSetForeground(theDisplay,theGC,White.pixel); 
}

void fixpix()
{
  int i,k;
  
  for(i=0;i<nd[1];i++) {
   if(xpos <= wave[i] && xpos >= wave[i-1]) {
    if(fabs(xpos - wave[i]) < fabs(xpos - wave[i-1])) k = i;
    else k = i-1;
    break;
   }
  }
  flux[k] = 0.5*(flux[k-1]+flux[k+1]);
  fixwave[nfix] = wave[k];
  nfix++;
  for(i=0;i<nd[nf];i++) {
   iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
   iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
  }
}
  


void normalize()
{
 int i,n;
 char tmp[300],*tmp1,norname[300];
 FILE *out;
 time_t now;

 if(nf > 1) {
   printf("Cannot normalize more than one spectrum at a time\n");
   return;
 }

 now = time(NULL);

 for(i=0;i<nd[nf];i++) flux[i] /= ynor;
 strcpy(tmp,fname[0]);
 tmp1 = strrchr(tmp,'.');
 n = tmp1-tmp;
 strncpy(norname,tmp,n);
 norname[n] = '\0';
 strcat(norname,".nor");
 out = fopen(norname,"w");
 printf("Outputting normalized spectrum in file %s\n",norname);
 sprintf(head[nh],"#NORMALIZED %s at lambda = %9.7g    %s",
       fname[0],xnor,ctime(&now));
 nh++; 
 for(i=0;i<nd[nf];i++) fprintf(out,"%9.3f %f\n",wave[i],flux[i]);
 for(i=0;i<nh;i++) fprintf(out,"%s",head[i]);
 fclose(out);
 ylow = yhigh = flux[0];
 for(i=0;i<nd[nf];i++) {
    if(xlow > wave[i]) xlow = wave[i];
    if(xhigh < wave[i]) xhigh = wave[i];
    if(ylow > flux[i]) ylow = flux[i];
    if(yhigh < flux[i]) yhigh = flux[i];
 }   
 scMaxInterval(xlow,xhigh,10,&nxlow,&nxhigh,&nxtics);
 scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
 xlow = nxlow;
 xhigh = nxhigh;
 xtics = nxtics;
 ylow = nylow;
 yhigh = nyhigh;
 ytics = nytics;
 for(i=0;i<nd[nf];i++) {
   iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
   iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
 }
}



void loadspectrum()
{
 int i,j;
 FILE *in;
 char tmp[20];
 double offset;


 while(findfiles(infile) != 0) {
   printf("\nEnter name of spectrum files > ");
   ggets(infile);            
 }
 strcpy(title,infile);

 nf = 0;
 fname[0] = strtok(infile,"+ ");
 for(i=1;i<9;i++) {
    if((fname[i] = strtok(NULL,"+ ")) == NULL) {  
      nf = i;
      break;
    }
 }

 nd[0] = 0;
 for(i=0;i<nf;i++) {
    if(mkgrab(fname[i],wave,flux,1,2,i) == 0) {
      nf = i;
      break;
    }
 }

 offset = 0.0;
 if(nf > 1) {
   printf("\nEnter offset > ");
   ggets(tmp);
   offset = atof(tmp);
 }
 /* printf("nf = %d  nd[nf] = %d\n",nf,nd[nf]); */

 if(nf > 1) {
   for(j=1;j<nf;j++) {
     for(i=nd[j];i<nd[j+1];i++) 
       flux[i] -= offset*(double)j;
   }
 }


 xlow = xhigh = wave[0];
 ylow = yhigh = flux[0];
 for(i=0;i<nd[nf];i++) {
    if(xlow > wave[i]) xlow = wave[i];
    if(xhigh < wave[i]) xhigh = wave[i];
    if(ylow > flux[i]) ylow = flux[i];
    if(yhigh < flux[i]) yhigh = flux[i];
 }
 scMaxInterval(xlow,xhigh,10,&nxlow,&nxhigh,&nxtics);
 scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
 xlow = nxlow;
 xhigh = nxhigh;
 xtics = nxtics;
 ylow = nylow;
 yhigh = nyhigh;
 ytics = nytics;
 for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
 }
}

int autorec_action(caddr_t data)
{
  int i;  

  XUndefineCursor(theDisplay,theMain);
  XDefineCursor(theDisplay,theMain,Circle);
  autorec(wave,flux,nd[1],&nar);
  printf("nar = %d\n",nar);
  for(i=0;i<nar;i++) {
     ixar[i] = x1 + (x2 - x1)*(xar[i]-xlow)/(xhigh-xlow);
     iyar[i] = Y1 + (y2 - Y1)*(yar[i]-ylow)/(yhigh-ylow);
  }
  flagR = 1;
  XClearWindow(theDisplay,theMain);  
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux); 
  xplotr();
  return 1;

}

int normal_action(caddr_t data)
{     
 
  XUndefineCursor(theDisplay,theMain);
  XDefineCursor(theDisplay,theMain,Circle);
  flagN = 1;   
  return 1;
}

int fix_action(caddr_t data)
{
  if(flagF == 0) flagF = 1;
  else flagF = 0;
  flagN = flagS = flagR = 0;
  if(flagF == 1) {
    XUndefineCursor(theDisplay,theMain);
    XDefineCursor(theDisplay,theMain,Circle);
  }
  if(flagF == 0) {
    XUndefineCursor(theDisplay,theMain);
    XDefineCursor(theDisplay,theMain,crosshair);
  }
  if(flagF == 1) {
    printf("\nFix Pixel function is ON.  Click on defective pixel to fix\n");
    printf("To turn fix pixel facility off, click on Fix button again\n");
  }
  if(flagF == 0) printf("\nFix Pixel function is OFF\n");
  return 1;
}

int save_action(caddr_t data)
{
  char outfile[300];
  FILE *out;
  int i;
  time_t now;

  now = time(NULL);

  XUndefineCursor(theDisplay,theMain);
  XDefineCursor(theDisplay,theMain,crosshair);
  flagN = flagS = flagR = flagF = 0;
  printf("\nThis function saves to a file spectrum 1.  It may be used to");
  printf("\nsave smoothed spectra or spectra with fixed pixels\n");
  printf("\nEnter name of output file > ");
  ggets(outfile);
  out = fopen(outfile,"w");
  for(i=0;i<nd[1];i++) fprintf(out,"%9.3f %g\n",wave[i],flux[i]);
  if(sum1 == 0.0 && pts == 0.0 && nfix == 0)
     sprintf(head[nh],"#SAVED %s in %s with no modifications on %s",fname[0],
	  outfile,ctime(&now));  
  else
     sprintf(head[nh],"#SAVED %s in %s with modifications on %s",fname[0],
	  outfile,ctime(&now));
  nh++;
  if(sum1 != 0.0) {  
    sprintf(head[nh],"#SHIFTED %f in wavelength %s",sum1,ctime(&now));
    nh++;
  }
  if(pts != 0.0) {
    sprintf(head[nh],"#LOWPASS smoothed with %5.2f points %s",pts,ctime(&now));
    nh++;
  }
  for(i=0;i<nfix;i++) {
    sprintf(head[nh],"#FIXED pixel at %f  %s",fixwave[i],ctime(&now));
    nh++;
  }
  for(i=0;i<nh;i++) fprintf(out,"%s",head[i]);
  printf("\nSpectrum saved in file %s\n",outfile);
  fclose(out);
}

int scaleflux_action(caddr_t data)
{
  int choice = 0;
  char outfile[300],tmp[10];
  int i;
  FILE *out;
  double fac;

  printf("\nThis function can be used to scale the flux of spectrum 1");
  printf("\nChoose from the following menu: \n");
  printf("\n1) Save spectrum 1 with the present flux scale");
  printf("\n2) Scale the flux of spectrum 1");
  printf("\nEnter choice > ");
  ni = scanf("%d",&choice);
  ggets(tmp);

  if(choice == 1) {
    printf("\nEnter name of output file > ");
    ggets(outfile);
    out = fopen(outfile,"w");
    for(i=0;i<nd[1];i++) fprintf(out,"%9.3f %g\n",wave[i],flux[i]);
    fclose(out);
    printf("\nSpectrum 1 saved in %s\n",outfile);
    return(1);
  }

  if(choice == 2) {
    printf("\nEnter scaling factor > ");
    ni = scanf("%lg",&fac);
    ggets(tmp);
    for(i=0;i<nd[1];i++) flux[i] *= fac;
    for(i=0;i<nd[nf];i++) {
      if(ylow > flux[i]) ylow = flux[i];
      if(yhigh < flux[i]) yhigh = flux[i];
    }   
    scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
    ylow = nylow;
    yhigh = nyhigh;
    ytics = nytics;
    for(i=0;i<nd[nf];i++) {
      iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    }
    XClearWindow(theDisplay,theMain);
    xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
    xplot(iwave,iflux);
    return 1;
  }
  return 1;
}


int accept_action(caddr_t data)
{
 int i,rt,n;
 char tmp[300],*tmp1;
 FILE *out;
 time_t now;

 now = time(NULL);

 if(flagR == 0) return 1;
 if(flagS == 1) flagS = 0; 
 XUndefineCursor(theDisplay,theMain);
 XDefineCursor(theDisplay,theMain,crosshair);
 strcpy(tmp,fname[0]);
 tmp1 = strrchr(tmp,'.');
 n = tmp1-tmp;
 strncpy(recname,tmp,n);
 recname[n] = '\0';
 strcat(recname,".rec");
 out = fopen(recname,"w");
 printf("nd[1] = %ld\n",nd[1]);
 rt = autorectify();
 flagR = 0;
 xlow = xhigh = wave[0];
 ylow = yhigh = flux[0];
 nf = 1;
 for(i=0;i<nd[nf];i++) {
    if(xlow > wave[i]) xlow = wave[i];
    if(xhigh < wave[i]) xhigh = wave[i];
    if(ylow > flux[i]) ylow = flux[i];
    if(yhigh < flux[i]) yhigh = flux[i];
 }   
 scMaxInterval(xlow,xhigh,10,&nxlow,&nxhigh,&nxtics);
 scMaxInterval(ylow,yhigh,10,&nylow,&nyhigh,&nytics);
 xlow = nxlow;
 xhigh = nxhigh;
 xtics = nxtics;
 ylow = nylow;
 yhigh = nyhigh;
 ytics = nytics;
 printf("Outputting rectified spectrum in file %s\n",recname);
  for(i=0;i<nd[nf];i++) {
    iwave[i] =  x1 + (x2 - x1)*(wave[i]-xlow)/(xhigh-xlow);
    iflux[i] =  Y1 + (y2 - Y1)*(flux[i]-ylow)/(yhigh-ylow);
    fprintf(out,"%f %f\n",wave[i],flux[i]);
  }
  if(pts != 0) {
   sprintf(head[nh],"#RECTIFIED original data using %5.2f pt low-pass smoothed continuum pts %s %s",pts,fname[0],ctime(&now));
   pts = 0;
  } else sprintf(head[nh],"#RECTIFIED %s  %s",fname[0],ctime(&now));
  nh++;
  for(i=0;i<nh;i++) fprintf(out,"%s",head[i]);
  fclose(out);
  XClearWindow(theDisplay,theMain);
  xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,Y1,y2);
  xplot(iwave,iflux);
  return 1;
}



void dot(x,y)
int x,y;
{
  XDrawRectangle(theDisplay,theMain,theGC,x-1,y-1,2,2);
  XDrawPoint(theDisplay,theMain,theGC,x,y);
  return;
}

void circle(x,y)
int x,y;
{
  XDrawArc(theDisplay,theMain,theGC,x-4,y-4,8,8,0,360*64);
  return;
}

void filledcircle(x,y)
int x,y;
{
  XFillArc(theDisplay,theMain,theGC,x-4,y-4,8,8,0,360*64);
  return;
}

void Remove(xrr,xl,xh)
double xrr;
double xl,xh;
{
  double del;
  int i,j;
  
  del = fabs(xh-xl)/200.0;
  
  for(i=0;i<nar;i++) {
    if(fabs(xrr-xar[i]) < del) {
      for(j=i;j<nar-1;j++) {
        xar[j] = xar[j+1];
        yar[j] = yar[j+1]; 
      }
      nar--;
    }
  }  
}


void eqw1(xs,xe)
int xs,xe;
{

   int i,j,k;
   double wl,wh;
   double w,cont1,cont2;
   double xe1,xe2,ye1,ye2;

   wl = xlow + (double)(xs-x1)*(xhigh-xlow)/(double)(x2-x1);
   wh = xlow + (double)(xe-x1)*(xhigh-xlow)/(double)(x2-x1);

   for(i=0;i<nd[1]-1;i++) {
      if(wl < wave[i+1] && wl >= wave[i]) {
          j = i;
          break;
      }
   }
   for(i=j;i<nd[1]-1;i++) {
      if(wh <= wave[i+1] && wh > wave[i]) {
          k = i;
          break;
      }
   }

   xe1 = wave[j];
   xe2 = wave[k];
   ye1 = flux[j];
   ye2 = flux[k];
   w = 0.0;

   for(i=j;i<=k;i++) {
     cont1 = ye1 + (ye2-ye1)*(wave[i]-xe1)/(xe2-xe1);
     cont2 = ye1 + (ye2-ye1)*(wave[i+1]-xe1)/(xe2-xe1);
     cont1 = 1.0 - flux[i]/cont1;
     cont2 = 1.0 - flux[i+1]/cont2;
     w += (cont1+cont2)*(wave[i+1]-wave[i])/2.0;
   }

   printf("\nEquivalent width = %6.1f mA\n",w*1000.0);
   return;
}

void eqw2(xs1,xs2,xE1,xE2)
int xs1,xs2,xE1,xE2;
{
   int i,j1,j2,k1,k2,jmid,kmid,l,m;
   double wl1,wl2,wh1,wh2,mwl,mwh;
   double xe1,xe2,ye1,ye2,w;
   double cont1,cont2,c1,c2;
   int ix1,ix2,iy1,iy2;

   wl1 = xlow + (double)(xs1-x1)*(xhigh-xlow)/(double)(x2-x1);
   wl2 = xlow + (double)(xs2-x1)*(xhigh-xlow)/(double)(x2-x1);
   wh1 = xlow + (double)(xE1-x1)*(xhigh-xlow)/(double)(x2-x1);
   wh2 = xlow + (double)(xE2-x1)*(xhigh-xlow)/(double)(x2-x1);
   mwl = (wl1+wl2)/2.0;
   mwh = (wh1+wh2)/2.0;


   printf("\n%8.2f  %8.2f  %8.2f  %8.2f\n",wl1,wl2,wh1,wh2);

   for(i=0;i<nd[1]-1;i++) {
      if(wl1 < wave[i+1] && wl1 >= wave[i]) {
          j1 = i;
          break;
      }
   }
   for(i=j1;i<nd[1]-1;i++) {
      if(wl2 < wave[i+1] && wl2 >= wave[i]) {
          j2 = i;
          break;
      }
   }
   for(i=j2;i<nd[1]-1;i++) {
      if(wh1 <= wave[i+1] && wh1 > wave[i]) {
          k1 = i;
          break;
      }
   }
   for(i=k1;i<nd[1]-1;i++) {
      if(wh2 <= wave[i+1] && wh2 > wave[i]) {
          k2 = i;
          break;
      }
   }
   jmid = (j1+j2)/2;
   kmid = (k1+k2)/2;
   cont1 = 0.0;
   for(i=j1;i<=j2;i++) cont1 += flux[i];
   cont1 /= (double)(j2-j1+1);
   cont2 = 0.0;
   for(i=k1;i<=k2;i++) cont2 += flux[i];
   cont2 /= (double)(k2-k1+1);
   
   iy1 = Y1 + (y2 - Y1)*(cont1-ylow)/(yhigh-ylow);
   iy2 = Y1 + (y2 - Y1)*(cont2-ylow)/(yhigh-ylow);   
   ix1 = x1 + (x2 - x1)*(mwl-xlow)/(xhigh-xlow);
   ix2 = x1 + (x2 - x1)*(mwh-xlow)/(xhigh-xlow);
   XSetForeground(theDisplay,theGC,Green.pixel);
   Drawline(ix1,iy1,ix2,iy2);
   ix1 = x1 + (x2 - x1)*(wl1-xlow)/(xhigh-xlow);
   ix2 = x1 + (x2 - x1)*(wl2-xlow)/(xhigh-xlow);
   XSetForeground(theDisplay,theGC,Red.pixel);
   Drawline(ix1,iy1,ix2,iy1);
   ix1 = x1 + (x2 - x1)*(wh1-xlow)/(xhigh-xlow);
   ix2 = x1 + (x2 - x1)*(wh2-xlow)/(xhigh-xlow);
   Drawline(ix1,iy2,ix2,iy2);
   XSetForeground(theDisplay,theGC,White.pixel);

   w = 0.0;
   for(i=j2;i<=k1;i++) {
     c1 = cont1 + (cont2-cont1)*(wave[i]-mwl)/(mwh-mwl);
     c2 = cont2 + (cont2-cont1)*(wave[i+1]-mwl)/(mwh-mwl);
     c1 = 1.0 - flux[i]/c1;
     c2 = 1.0 - flux[i+1]/c2;
     w += (c1+c2)*(wave[i+1]-wave[i])/2.0;
   }

   printf("\nEquivalent width = %6.1f mA\n",w*1000.0); 

   flagw = 0;

   return;
}

void lineflux(xs,xe)
int xs,xe;
{

   int i,j,k;
   double wl,wh;
   double flx1,contflx;
   double xe1,xe2,ye1,ye2;
   char ans[10];

   if(flagsc == 0 && flagLF == 1) {
     printf("\nSet continuum using Set Continuum button first!!\n");
     flagLF = 0;
     return;
   }
   if(flagsc == 0 && flagLF == 2) {
     flagLF = 0;
     return;
   }

   wl = xlow + (double)(xs-x1)*(xhigh-xlow)/(double)(x2-x1);
   wh = xlow + (double)(xe-x1)*(xhigh-xlow)/(double)(x2-x1);

   for(i=0;i<nd[1]-1;i++) {
      if(wl < wave[i+1] && wl >= wave[i]) {
          j = i;
          break;
      }
   }
   for(i=j;i<nd[1]-1;i++) {
      if(wh <= wave[i+1] && wh > wave[i]) {
          k = i;
          break;
      }
   }

   xe1 = wave[j];
   xe2 = wave[k];
   /*   ye1 = flux[j];
	ye2 = flux[k];  */
   ye1 = y1c + (y2c-y1c)*(xe1-x1c)/(x2c-x1c);
   ye2 = y1c + (y2c-y1c)*(xe2-x1c)/(x2c-x1c);
   contflx = 0.5*(ye1+ye2)*(xe2-xe1);
   flx1 = 0.0;

   for(i=j;i<k;i++) {
     flx1 += 0.5*(wave[i+1]-wave[i])*(flux[i]+flux[i+1]);
   }
   flx1 -= contflx;

   printf("\nLine Flux = %e\n",flx1);
   printf("\nTry again y/n? > ");
   ggets(ans);
   if(strcmp(ans,"y") == 0) return;
   else {
     flagsc = 0;
     flagSC = 0;
     XUndefineCursor(theDisplay,theMain);
     XDefineCursor(theDisplay,theMain,crosshair);
     flagLF = 0;
     printf("Line flux facility off\n");
   }
   return;
}

void counts(xs,xe)
int xs,xe;
{

   int i,j,k;
   double wl,wh;
   double counts,contcounts;
   double xe1,xe2,ye1,ye2;

   wl = xlow + (double)(xs-x1)*(xhigh-xlow)/(double)(x2-x1);
   wh = xlow + (double)(xe-x1)*(xhigh-xlow)/(double)(x2-x1);

   for(i=0;i<nd[1]-1;i++) {
      if(wl < wave[i+1] && wl >= wave[i]) {
          j = i;
          break;
      }
   }
   for(i=j;i<nd[1]-1;i++) {
      if(wh <= wave[i+1] && wh > wave[i]) {
          k = i;
          break;
      }
   }

   xe1 = wave[j];
   xe2 = wave[k];
   ye1 = flux[j];
   ye2 = flux[k];
   contcounts = 0.5*(ye1+ye2);
   counts = 0.0;

   for(i=j;i<k;i++) {
     counts += flux[i] - contcounts;
   }
   

   printf("\nCounts = %e\n",counts);
   return;
}


void neon(x,y,xneon)
double *x;
double *y;
double xneon;
{
  int n,i,k,j;
  double maxy,sum1,sum2,centroid;

  n = nd[1];

  for(i=0;i<n;i++) {
    if(xneon <= x[i]) {
      k = i;
      break;
    }
  }

  maxy = y[k];
  j = k;
  for(i=k-rad;i<=k+rad;i++) {
    if(y[i] > maxy) {
      j = i;
      maxy = y[i];
    }
  }

  sum1 = 0.0;
  sum2 = 0.0;
  for(i=j-rad;i<=j+rad;i++) {
    sum1 += x[i]*y[i];
    sum2 += y[i];
  }

  centroid = sum1/sum2;
  printf("Centroid = %9.3f\n",centroid);
}

void rect()
{
  double xmid;

  xmid = (xlow + xhigh)/2.0;
  xlrec = xmid - wRect/2.0;
  xhrec = xmid + wRect/2.0;
  ixlrec = x1 + (x2 - x1)*(xlrec-xlow)/(xhigh-xlow);
  ixhrec = x1 + (x2 - x1)*(xhrec-xlow)/(xhigh-xlow);
  iylrec = Y1 + (y2 - Y1)*(0.0-ylow)/(yhigh-ylow);
  iyhrec = Y1 + (y2 - Y1)*(1.0-ylow)/(yhigh-ylow);
  XSetForeground(theDisplay,theGC,Red.pixel);    
  Drawline(ixlrec,iylrec,ixlrec,iyhrec);
  Drawline(ixhrec,iylrec,ixhrec,iyhrec);
  XSetForeground(theDisplay,theGC,White.pixel);

  return;
}

void srect()
{
  double xmid;
  double sum = 0.0;
  double flx,dwave;
  int i;

  xmid = (xlow + xhigh)/2.0;
  xlrec = xmid - wRect/2.0;
  xhrec = xmid + wRect/2.0;
  dwave = dw*4.0;

  for(i=0;i<nd[1];i++) {
    if(wave[i-1] <= xlrec && wave[i] > xlrec) {
      flx = flux[i-1] + (flux[i]-flux[i-1])*(xlrec-wave[i-1])/
                        (wave[i]-wave[i-1]);
      sum += (1.0 - 0.5*(flx + flux[i]))*(wave[i] - xlrec);
    } else if(wave[i-1] <= xhrec && wave[i] > xhrec) {
      flx = flux[i-1] + (flux[i]-flux[i-1])*(xhrec-wave[i-1])/
                        (wave[i]-wave[i-1]);
      sum += (1.0 - 0.5*(flx + flux[i]))*(xhrec - wave[i-1]);
    } else if(wave[i] >= xlrec && wave[i] <= xhrec) 
         sum += (1.0 - 0.5*(flux[i-1] + flux[i]))*dwave;
    else sum += 0.0;
  }
  sum *= 1000.0;

  printf("\nStrength = %7.2f\n",sum); 

}

char *ggets(char *s)
{
  size_t n;
  char tmp[300];

  if(fgets(tmp,300,stdin) == NULL) {
    printf("Access error in ggets\n");
    exit(1);
  }
  n = strlen(tmp);
  strncpy(s,tmp,n-1);
  s[n-1] = '\0';
  return(s);
}
